<p>Datenquellen bilden die Grundlage der Report-Definitionen. Sie enthalten die physischen Namen der Tabellen und Spalten
in der Datenbank und viele weitere Informationen, die den Anwender bei der Erstellung der Reports unterstützen. Dazu gehören insbesondere:</p>  

<ol>
  <li> Der physische Name der Tabelle und eine fachliche Beschreibung,</li>
  <li> Werte, die für die Erzeugung von Zeilen und Spalten verwendet werden (&quot;Zeilen&quot;),</li>
  <li> Berechnete Werte für die Anzeige in den Werte-Zellen der Tabellen,</li> 
  <li> Filter zur Auswahl der Daten, die in den Report eingehen,</li> 
  <li> die Namen der Datenquellen, die bei der Report-Erstellung mit dieser Datenquelle verknüpft werden können.</li>
</ol>

<p>Hier werden interne Namen und Label vergeben. Der Benutzer sieht bei der Erstellung von Reports nur noch die Label. 
Die internen Namen werden in der Abfrage bei der Erstellung der temporären Tabellen verwendet. Es müssen gültige Namen für die
jeweilige Datenbank sein. Alle Bezeichnungen müssen ohne Berücksichtigung der Groß-/Klein-Schreibung eindeutig sein.</p>  

<h4>Verwendung physischer Namen aus der Datenbank</h4>
<p>Wenn z.B. in den Select-Feldern und in Filter physische Namen aus der Datenbank verwendet werden, 
sollten diese bei der Spezifikation von Dimensionen
grundsätzlich den Tabellen-Qualifier 'dim.', z.B. 'dim.name' erhalten. Dieser wird beim Verknüpfen entsprechend ersetzt.</p>
<p>Bei der Spezifikation von normalen Datenquellen
sollte für Spalten aus der Basistabelle der Tabellen-Qualifier 'base.', z.B. 'base.wert' verwendet werden. Bei Spalten aus den
Dimensions-Tabellen muss der Tabellen-Qualifier 'dNR.' mit NR als Dimensions-Nummer verwendet werden, z.B. 'd2.name'.</p> 
 
<h4>Erfassungsmasken</h4> 
<p>Eine Datenquelle kann als Datenabfrage oder als Erfassungsmaske angelegt werden. Aktuell ist nur der Typ "Erfassung (Standard)" 
implementiert. Dabei können Werte als Eingabefelder deklariert werden. Für das Eingabefeld wird dann zusätzlich der Name einer
Spalte in der Tabelle angegeben.</p> 
<p>Wenn bereits ein Wert ermittelt wurde, werden nach der Eingabe eines anderen Werts alle Werte zu der jeweiligen Gruppe 
proportional geändert. Wenn z.B. eine 1 mit einer 2 überschrieben wird, werden alle Werte, die in die Berechnung an dieser
Stelle eingegangen sind, verdoppelt.</p> 
<p>Die Verarbeitung einer initialen Eingabe (in ein leeres Feld) hängt vom Typ des des Wertes ab. Geldbeträge werden auf
ale Tabellenzeilen, die in die Berechnung an dieser Stelle eingehen, gleichverteilt. Bei allen anderen Typen wird der 
eingegebene Wert kopiert.</p> 
<p>Die Anzeige (z.B. in den Summen) wird erst aktualisiert, wenn die Tabelle neu aufgebaut wird.</p> 
<h4>Dimensionen</h4>
<p>Dimensionen ersetzen die Verknüpfung von Daten für Zeilen, Spalten und Filter
in Datenbank-Views. Sie werden als eine besondere Form von Datenquellen erstellt und
bei der Erstellung von Datenquellen verknüpft.</p>
<p>Siehe das entsprechende Unterkapitel unten.</p>