<p>Filter werden zur Auswahl der Daten für den Report verwendet. Sie können auch bei der Beschreibung von Zeilen und Werten
mit angelegt werden. 
<br><b>Ausnahme</b>: Bei Werten wirken nur Sonderfilter auf die Datenabfrage. Normale Filter wirken hier in
der Anzeige. Dabei wird der Filter auf den gerade anzuzeigenden Wert angewandt. Das ist besonders relevant für bis-Werte. 
Sollen große Einzelwerte unterdrückt werden, muss die Wirkung in der Report-Definition auf die Spalte dieser Werte begrenzt werden,
damit die höheren Summen-Werte trotzdem angezeigt werden.</p> 
<p>Folgende Typen sind möglich:</p> 
<ul>
<li> Text (enthält): Nur für Spalten von Typ Text. Platzhalter mit dem %-Zeichen sind ebenfalls möglich.</li> 
<li> Text (genau): Standard-Eingabe für alle Stalten-Typen. Bei Dezimalzahlen mit Tausender-Punkten und Dezimalkomma.</li>
<li> Text mit Label: Nur für Zeilen-Variablen: Die Filtereingabe ist der Text aus dem ersten Select. Angezeigt wird
aber der Ausdruck aus Select für Anzeige.</li>
<li> von bis: Es können bis zu zwei Werte angegeben werden. Die Abfrage erfolgt mit "größer gleich" bzw. "kleiner gleich".</li> 
<li> Auswahl und Auswahl von bis: Wie Text bzw. von bis, aber die Werte werden über eine Auswahlliste selektiert.</li>   
<li> Liste: In einer Auswahlliste können mehrere Werte ausgewählt oder ausgeschlossen werden.</li>   
<li> Sonderfilter: Einfacher Filter ohne weitere Spezifikation. Der komplette Where-Ausdruck steht im Select-Feld. <b>Dieser Typ 
sollte nur noch in besonderen Ausnahmefällen verwendet werden.</b></li>
<li> Sonderfilter mit Auswahl: Komplexer Filter mit verschiedenen Optionen. "Optionen eingeben" öffnet eine weitere 
Maske, in der der Filter-Text für den Benutzer und der Filter-Code, d.h. die Where-Klausel, eingegeben wird. Dieser Filter-Typ
ersetzt auch den einfachen Sonderfilter.<br>Hintergrund: Beim Verknüpfen von Datenquellen werden die Filter-Einstellungen soweit wie möglich
vererbt. Wenn die Vererbung nicht gewünscht ist, muss sie mit einem leeren, d.h. nicht gesetzten Filter für die 
verknüpfte Datenquelle unterbrochen werden. Das geht aber bei einem einfachen Sonderfilter nicht.</li> 
</ul>
<p>Bei "Text mit Label" und bei den Auswahllisten kann in "Select für Anzeige" die Anzeige für den Benutzer unabhängig 
vom selektierten Wert spezifiziert werden. Die verschiedenen Möglichkeiten, der dazu erforderlichen Auswahllisten
werden im Unterkapitel 
<?php if ($level >= 10) echo "<a href='#Anzeige' onclick=\"anzeige('dqFilterListen');\">"
?>Filter-Listen<?php 
if ($level >= 10) echo "</a>"?>
beschrieben.
</p>




<h4>Liste</h4>
<p>Normalerweise wird diese Liste über die Abfrage der Basis-Tabelle mit allen anderen Filter aufgebaut.
Der Beutzer kann dann einzelne Werte auswählen oder ausschließen.</p> 
<p>Es kann aber auch eine (Schlüssel-)Tabelle mit den möglichen Werten angegeben werden. Die Anzeige dieser
Werte erfolgt dann gemäß der Logik bei einfachen Auswahllisten.</p> 
<p>in Select-Name steht der Ausdruck für die Where-Klausel, in Select für Anzeige steht der Ausdruck für die 
Anzeige in der Liste. Die Liste kann intern, nach Select-Name, oder nach der Anzeige auf- oder absteigend sortiert werden.</p>  

<h4>Auswahl und Auswahl von-bis</h4>
<p>Die Auswahllisten können über "<b>Optionen eingeben</b>" als Wert-/Anzeige-Paare manuell erstellt werden. 
Dazu kann die aktuelle Datenbank-Tabelle auch mit "einlesen" nach den vorkommenden Werten durchsucht werden.
Bei "Einlesen nach Anzeige" wird nach der Anzeige statt nach dem internen Wert sortiert.</p>  
<p> Alternativ kann eine <b>Datenbank-Tabelle</b> mit den Werten für die Auswahl angegeben werden. 
Die Sortierung der Auswahl wird dann über die Drop-Down-Box spezifiziert. Dann kann die Auswahl auch durch 
zusätzliche Filter eingeschränkt werden. 
<ul>
<li> In Filter-Spalte 1 kann ein Filter angegeben werden, der direkt auf die Auswahlliste angewandt wird.
<li> In "Zweite Werte-Tabelle zum Eingrenzen" kann eine zweite Tabelle angegeben werden, auf die der 
zweite Filter angewandt wird. Diese zweite Tabelle mus nur die Select-Klausel für die Werte und den zweiten Filter
bedienen können. Bleibt dieses Feld leer, wirkt die Eingabe in "Filter-Spalte für zweite Werte-Tabelle" auf
die Tabelle der Auswahlliste.
</ul>
<p>Technisch ist es möglich, hier die physische Tabelle der Datenquelle anzugeben. Bei größeren Tabellen führt das aber 
zu erheblichen Performance-Einbußen bei der Report-Erstellung, weil die Auswahl-Tabellen auch bei der Erstellung 
der Reports komplett aufgebaut werden.</p> 
<p>Eine dritte Möglichkeit ist die Angabe einer <b>Datenquelle vom Typ Auswahlliste</b>. Dabei wird ein #-Zeichen gefolgt 
von dem Namen der Datenquelle angegeben. Diese Datenquelle muss eine Zeilen-Spezifikation mit dem Namen des Filters
enthalten. Beim Aufbau der Auswahlliste werden dann alle gesetzten Filter aus der Datenquuelle berücksichtigt,
die in der Quelle zur Auswahlliste als Filter oder als Zeilen oberhalb des Filters definiert sind. 
Wenn der Filter aus einer Dimension kommt, kann auch die Dimensions-Tabelle mit einem einfachen #-Zeichen verwendet werden.<br> 
Siehe Unterkapitel "Auswahlliste".</p> 

<h4>Wert bei Sonderfilter anzeigen</h4>
<p>Sonderfilter enthalten in der Regel eine logische Definition, die sich auch auf die Daten beziehen kann, z.B. "aktuell" 
oder "Vorjahr". In diesen fällen kann es sinnvoll sein, dass im Report, der tatsächlich selektierte Wert angezeigt wird.<br>
Beispielsweise wird das Intervall für die Auswahl von Monatswerten mit fogender Klausel angezeigt:<pre>
case
   when min(base.berichtsmonat) < max(base.berichtsmonat) then 
        concat ( substr(min(base.berichtsmonat),1,4),'/',substr(min(base.berichtsmonat),6,2)
                ,' - ',substr(max(base.berichtsmonat),1,4),'/',substr(max(base.berichtsmonat),6,2)) 
   else concat(substr(max(base.berichtsmonat),1,4),'/',substr(max(base.berichtsmonat),6,2))  
end
</pre></p>
 

<h4>Notwendige Filter</h4>
<p>Bei großen Datenbank-Tabellen, aber auch bei Zeitreihen, kann die Auswertung der kompletten Tabelle verhindert werden,
indem ein oder mehrere Filter als notwendig deklariert werden. Dabei sind bis zu 9 Gruppen möglich,
aus denen jeweils mindestens ein Filter gesetzt sein muss.</p>


