<p>Der Klick auf den Namen einer Zeile, eines Werts oder eines Filters öffnet den Metadaten-Editor 
für das jeweilige Element.</p>
<p>Folgende Eingaben sind möglich:</p> 
<ul>
<li> <b>Wo</b>: Hier kann das Element zwischen Zeilen, Werten und Filter verschoben werden.</li>

<li> <b>Label</b>: Bezeichnung für die Anzeige in der Report-Definition und Spaltenüberschrift 
in den Reports.</li>

<li> <b>Beschreibung</b>: Ausführliche Beschreibung, die bei der Erstellung der Reports und in den Ausgaben 
über das <span class="help">Info-Symbol</span> angezeigt wird.</li>

<li> <b>Typ</b>: Typ des Select-Ausdrucks. Ganze Zahlen erhalten keine Tausenderpunkte. 
Tausender-Punkte erhalten sie als Dezimalzahlen ohne Nachkommastellen. Bei Geldbeträgen kann in der 
Report-Definition auch die Einheit, Tsd, Mio oder Mrd., gewählt werden.</li>

<li> <b>HTML-Tag</b>: Nur bei Zeilen kann hiermit die Zelle als Etikett (th) oder als normale Datenzelle 
(td) ausgegeben werden.</li>

<li> <b>Ausrichtung</b>: Auswahlliste für Zeilen und Werte</li>

<li> <b>Nachkommastellen</b>: Nur für Dezimalzahlen und Geldbeträge</li>

<li> <b>Select-Name oder Ausdruck</b>: Physischer Name der Spalte in der Datenbank oder Select-Ausdruck.<br>
Bei Zeilen wird nach diesen Werten gruppiert und im Normalfall sortiert.<br> 
Bei Werten stehen hier normalerweise Statistiken
z.b. avg(betrag) für Mittelwerte oder sum(betrag) für Summen. Es können aber alle gültigen 
SQL-Select-Klauseln eingegeben werden. Auch Texte sind möglich, die dann aus der verknüpften 
Datenquelle angezeigt werden. (Zeilen-Texte sind nur aus der Basis-Quelle möglich).<br> 
Bei Filter steht hier ein gültiger Ausdruck für eine Where-Klausel, der mit dem 
ausgewählten Wert verglichen wird. (genaueres unter Filter).
</li>

<li> <b>Select für Anzeige</b>: Bei Zeilen kann hier ein zweiter Select-Ausdruck für die Anzeige angegeben werden. 
Select-Name... wird dann nur für die Gruppierung, die interne Sortierung und ggf. den Filter verwendet.
</li>


<li> <b>Filter-Typ</b>: Auswahlliste für einzelne Werte und Intervalle. Es stehen verschiedene
Text-Optionen und Varianten mit Auswahllisten zur Verfügung. 
<br>Sonderfilter sind einfache Auswahlen. In diesem Fall steht die komplette Where-Klausel
in Select-Name... - diese Option ist veraltet und sollte wegen Problemen bei der Vererbung in 
verknüpften Quellen und mit der Option 'erforderliche Filter' nicht mehr verwendet werden.
<br>Sonderfilter mit Auswahl enthalten eine oder mehere Optionen in der Auswahltabelle. Hier werden
eine Bezeichnung und die Where-Klausel in der Optionen-Liste eingetragen. Die Vererbung bei 
verknüpften Quellen erfolgt über die Bezeichnung, so dass z.B. die Auswahl "Vorjahr" in verschiedenen
verknüpften Datenquellen unterschiedlich umgesetzt werden kann. Diese Option ersetzt den Sonderfilter 
ohne Auswahl, weil sie auf inaktiv gesetzt werden kann, und dann bei verknüpften Datenquellen die 
Vererbung blockiert.     
<br>Auch Zeilen und Werte können als Filter verwendet werden. Bei Werten wirken nur Sonderfilter 
auf die Datenauswahl. Alle anderen wirken nur auf die Anzeige der Zeilen in der Ausgabe, also nicht
auf die Werte in den entsprechenden Summenzeilen (Werte-Filter). 
<ul>
<li> <b>Optionen</b>: Bei Auswahl, Auswahl von bis und Sonderfilter mit Auswahl wird hiermit ein
weiteres Fenster geöffnet, um die Auswahl-Optionen einzutragen. Normale Auswahllisten enthalten 
den Wert und ein Label-Text für die Anzeige. Bei Sonderfilter wird die Bezeichnung und die 
Where-Klausel engegeben. Aleternativ kann die Auswahl auch über eine Werte-Tabelle erfolgen.</li>
<li> <b>Filter erforderlich</b>: Mit dieser Option kann erzwungen werden, dass mindestens ein
Filter aus einer Gruppe tatsächlich gesetzt ist. Das ist für große Tabellen mit Detail-Sätzen
sinnvoll, die z.B. nur für einen Kunden oder einen Standort abgefragt werden sollen. 
Es sind neun Gruppen möglich.</li>
<li> <b>Werte-Tabelle</b>: Tabelle mit den auszuwählenden Werten. Es werden die Select-Angaben
für die Anzeige verwendet. Die Tabelle muss keine eindeutigen Werte enthalten, weil mit 
select distinct abgefragt wird. Allerdings wird die Angabe der physischen Tabelle nicht empfohlen,
weil die Auswahl auch bei der Erstellung des Reports aufgebaut wird, was zu Performance-Einbußen 
führen würde.<br>Weitere Optionen sind im <?php if ($level >= 10) echo "<a href='#Anzeige' onclick=\"anzeige('dqFilterListen');\">"
?>Unterkapitel Filter-Listen bei Filter<?php 
if ($level >= 10) echo "</a>"?>
beschrieben.
</li>
<li> <b>Sort</b>: Sortierung der Auswahlliste</li>
<li> <b>Filter-Spalte 1</b>: Name eines Filters für die Auswahlliste.<br>Wenn der Filter bei
der Erstellung der Report-Definition gesetzt ist, wird die Auswahlliste entsprechend eingeschränkt.
Der Filter wird auf die Auswahlliste angewendet. Die Auswahlliste muss deshalb auch die Spalten für diesen
Filter enthalten.
</li>
<li> <b>Zweite Werte-Tabelle zum Eingrenzen</b>: Zweite Werte-Tabelle zum Enschränken der Auswahlliste.
<br>Diese Tabelle muss die Select-Spalten der Auswahlliste und die Select-Spalten des zweiten Filters 
enthalten. Dabei kann es sich auch um die Auswahlliste selbst handeln, wenn sie die entsprechenden Spalten 
enthält.</li>
<li> <b>Filter-Spalte für zweite Werte-Tabelle</b>: Name eines zweiten Filters für die Auswahlliste.
<br>Wenn der Filter bei der Erstellung der Report-Definition gesetzt ist, wird die Auswahlliste 
über die zweite Tabelle entsprechend eingeschränkt.</li>


</ul>


</li>
<li> nur für Werte: 
<ul>
<li> <b>Chart-Farbe</b>: Farbe der Grafik-Balken bei positiven Werten in RGB-Hex-Notation. Z.B. #0000ff für blau.</li>
<li> <b>Chart-Farbe wenn negativ</b>: Farbe der Grafik-Balken bei negativen Werten in RGB-Hex-Notation. Z.B. #ff0000 für rot.</li>
<li> <b>Chart-Gruppe</b>: Die Grafik-Balken werden über das Minimum und Maximum der vorkommenden Werte skaliert.
Wenn verschiedene Werte dieselbe Skalierung erhalten sollen, können sie hier über einen Gruppen-Namen zusammengefasst werden.</li>
<li> <b>Chart-Skalierung</b>: Hier kann optional eine Unter- und Obergrenze für die Skalierung eingegeben werden, damit
einzelne Extremwerte die Charts nicht unbrauchbar machen.</li>

</ul>
</li>
</ul>

<p>Manchmal verdeckt die Fußzeile mit den Buttons den Editor. Deshalb kann sie über die Doppel-Pfeile <span class="clickFlaeche">&lt;&lt;</span>
ein- und wieder ausgefahren werden.</p>

<h4>Umbenennen</h4>
<p>Nach dem Initialisieren und nach dem importieren einer Dimension kann es sinnvoll sein, eine Variable umzubennen.
Aktuell ist das etwas versteckt gelöst: Ein Klick auf die Überschrift "Metadaten für ..." öffnet eine neue Zeile,
in der der Name geändert werden kann. Mit der Schaltfläche "umbenennen" wird die Umbenennung durchgeführt. Mit "abbrechen"
wird der Vorgang abgebrochen.</p>