<!-- AKTUELL NICHT MEHR VERWENDET
   Steht hier nur für die Dok. der Window-Filter -->
<p>Window-Funktionen sind eine relativ neue Klasse von Datenbank-Funktionen, die Zeilen-übergreifende Berechnungen
ermöglichen. Beispielsweise kann mit der Funktion ROW_NUMBER() eine Rangfolge der Zeilen nach einem
Ertragswert berechnet und so die Anzeige auf die n höchsten Erträge begrenzt werden.</p>
<p>Zur Maria-DB gibt es folgende Seiten (auf Englisch):<br>
Übersicht: <a href='https://mariadb.com/kb/en/window-functions-overview/' target='MariaDB'>https://mariadb.com/kb/en/window-functions-overview/</a><br>
Funktionen: <a href='https://mariadb.com/kb/en/window-functions/' target='MariaDB'>https://mariadb.com/kb/en/window-functions/</a><br>
Frames: <a href='https://mariadb.com/kb/en/window-frames/' target='MariaDB'>https://mariadb.com/kb/en/window-frames/</a></p>
<p>Im WS-Reporter werden diese Funktionen für "Anzeige-Filter" verwendet, mit denen die Ausgabe der Tabelle auf relevante 
Zelen eingeschränkt werden kann.</p>
<h4>Implementierung im WS-Reporter</h4>
<p>Im WS-Reporter wird der Select-Ausdruck ermittelt, nachdem alle Daten zusammengeführt wurden. 
Dieser Wert wird für die jeweilige Zeilen-Gruppe ermittelt, die bei der Report-Erstellung als "wirksam ab Spalte" angegeben wurde.</p>
<p>Technisch wird die Funktion in SQL wie folgt umgesetzt:<pre>
    <i>funktion</i>(<i>[Ausdruck]</i>) OVER (
       PARTITION BY [Zeilen bis zur gewählten Ebene]
       ORDER BY [gewählter Wert]
       )
</pre>
Die Selektion erfolgt dann bei der Erstellung der sortierten Tabelle für die Ausgabe.</p>
<p>In der Spezifikation der Datenquelle wird nur die Funktion, ggf. mit dem Klammer-Ausdruck, als Select-Ausdruck
angegeben. Der OVER-Ausdruck wird nach den Spezifikationen im Report-Ausdruck dynamisch erzeugt. Beispiele für Select-Ausdrücke:
<ul>
<li> ROW_NUMBER(): für Ranking</li>
<li> NTILE(nGrp): gruppiert in nGrp Gruppen, die dann bei der Report-Spezifikation selektiert werden.</li>
<li> PERCENT_RANK(), CUME_DIST(): Rang-Werte in %, um z.B. das oberste oder das unterste Drittel einer Gruppe auszugeben. Alternative zu NTILE().</li> 
<li> SUM(wert): Berechnet Gruppen-Summen. Dabei muss die "für Wert"-Auswahl auf "nicht aktiv" bleiben. 
Sonst würden kumulierten Summen berechnet werden, die für den Filter keinen Sinn ergeben würden. 
Der Wert muss qualifiziert mit 'base.' angegeben werden. Bei verknüpften Quellen passt
der WS-Reporter die Selektion dann an.</li>
</ul>
<p>In der Report-Definition wird dann die Grenze, z.B. '&lt;=3', eingegeben. Dabei können 1000er-Punkte und Dezimal-Kommas verwendet werden.</p> 
<h4>Beschreibung</h4>
<p>Damit solche Filter bei der Report-Definition sinnvoll verwendet werden können, müssen sie in der Datenquelle
ausführlich beschrieben werden. Neben dem Zweck des Filters, z.B. "Auswahl nach Rangfolge", muss beschrieben werden,
was im Feld Vergleich einzugeben ist.   
 
<p>Beispiele finden Sie unter "Report-Definitionen".</p>
