<?php
/**
 * Projekt: WS-Reporter
 *          Rollen-Verwaltung und Zuordnung von Reports
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    21.08.2022
 *
 */
$editUser="X";
include 'includes/defender.inc';
require_once './includes/funktionen.inc';
require_once './includes/classes.inc';
require_once './phpsec/createDBH.inc';
if (session_status() == PHP_SESSION_NONE)  session_start();

function checkStmt($erg){
    global $dbh, $stmt;
    if ($stmt === false){
        var_dump($dbh->errorInfo());
        var_dump($stmt);
    }
}


anmeldungPruefen();
adminRechteVerlangen();
// echo print_r($_REQUEST,true);

if (array_key_exists('action', $_REQUEST) && isValid($_REQUEST['action'])
    && array_key_exists('rolle', $_REQUEST) && isValid($_REQUEST['rolle'])){
    switch ($_REQUEST['action']){
        case 'neueRolle':
            if (isValid($_REQUEST['rolle'])){
            $stmt = $dbh->prepare('insert into wsrRollen set rolle= :rolle');
            checkStmt( $stmt->execute(array('rolle'=>$_REQUEST['rolle'])) );
            }
            break;
        case 'delRolle':
            if (isValid($_REQUEST['rolle'])){
                $stmt = $dbh->prepare('delete from wsrRollen where rolle= :rolle');
                checkStmt( $stmt->execute(array('rolle'=>$_REQUEST['rolle'])));
                $stmt = $dbh->prepare('delete from wsrReports where rolle= :rolle');
                checkStmt( $stmt->execute(array('rolle'=>$_REQUEST['rolle'])));
            }
            break;
        case 'selReport':
            if (isValid($_REQUEST['report'])){
                $sql = new SqlAbfrage('WSR');
                $sql->sql .= 'select max(SortNr) as maxSort from wsrReports';
                $sql->addSel('rolle =',  $_REQUEST['rolle']);
                checkStmt($stmt = $sql->execute());
                $z = $stmt->fetchObject();
                $maxSort = $z->maxSort +1;

                $sql = new SqlAbfrage('WSR');                
                $sql->sql = 'insert into wsrReports set';
                $sql->addKlausel('rolle = ', $_REQUEST['rolle']);
                $sql->addKlausel(', reportTitle = ', $_REQUEST['report']);
                $sql->addKlausel(', SortNr = ',$maxSort);
                $sql->execute();
            }
            break;
        case 'delReport':
            if (isValid($_REQUEST['report'])){
                $sql = new SqlAbfrage('WSR');                
                $sql->sql = 'delete from wsrReports';
                $sql->addSel('rolle = ', $_REQUEST['rolle']);
                $sql->addSel('reportTitle = ', $_REQUEST['report']);
                $sql->execute();
            }
            break;
        case 'upReport':
            if (isValid($_REQUEST['report'])){
                $sql = new SqlAbfrage('WSR');
                $sql->sql .= 'select SortNr from wsrReports';
                $sql->addSel('rolle = ', $_REQUEST['rolle']);
                $sql->addSel('reportTitle = ', $_REQUEST['report']);
                checkStmt($stmt = $sql->execute());
                $z = $stmt->fetchObject();
                $sortNr = $z->SortNr;

                $sql = new SqlAbfrage('WSR');
                $sql->sql .= 'select max(SortNr) as maxSort from wsrReports';
                $sql->addSel('rolle =',  $_REQUEST['rolle']);
                $sql->addSel('SortNr <',  $sortNr);
                checkStmt($stmt = $sql->execute());
                $z = $stmt->fetchObject();
                $maxSort = $z->maxSort;
                
                $sql = new SqlAbfrage('WSR');
                $sql->sql = 'update wsrReports set SortNr = SortNr+1 where SortNr = '.$maxSort;
                $sql->firstWhere = false;
                $sql->addSel('rolle =',  $_REQUEST['rolle']);
                $sql->execute();
                
                $sql = new SqlAbfrage('WSR');
                $sql->sql = 'update wsrReports set SortNr = '.$maxSort;
                $sql->addSel('rolle = ', $_REQUEST['rolle']);
                $sql->addSel('reportTitle = ', $_REQUEST['report']);                
                $sql->execute();                
            }
            break;
        case 'downReport':
            if (isValid($_REQUEST['report'])){
                $sql = new SqlAbfrage('WSR');
                $sql->sql .= 'select SortNr from wsrReports';
                $sql->addSel('rolle = ', $_REQUEST['rolle']);
                $sql->addSel('reportTitle = ', $_REQUEST['report']);
                checkStmt($stmt = $sql->execute());
                $z = $stmt->fetchObject();
                $sortNr = $z->SortNr;
                
                $sql = new SqlAbfrage('WSR');
                $sql->sql .= 'select min(SortNr) as minSort from wsrReports';
                $sql->addSel('rolle =',  $_REQUEST['rolle']);
                $sql->addSel('SortNr >',  $sortNr);
                checkStmt($stmt = $sql->execute());
                $z = $stmt->fetchObject();
                $minSort = $z->minSort;
                
                $sql = new SqlAbfrage('WSR');
                $sql->sql = 'update wsrReports set SortNr = SortNr-1 where SortNr = '.$minSort;
                $sql->firstWhere = false;
                $sql->addSel('rolle =',  $_REQUEST['rolle']);
                $sql->execute();
                
                $sql = new SqlAbfrage('WSR');
                $sql->sql = 'update wsrReports set SortNr = '.$minSort;
                $sql->addSel('rolle = ', $_REQUEST['rolle']);
                $sql->addSel('reportTitle = ', $_REQUEST['report']);
                $sql->execute();
                
            }
            break;
        case 'moveReport':
            if (isValid($_REQUEST['report']) && isValid($_REQUEST['ziel'])){
                $sql = new SqlAbfrage('WSR');
                $sql->sql .= 'select SortNr from wsrReports';
                $sql->addSel('rolle = ', $_REQUEST['rolle']);
                $sql->addSel('reportTitle = ', $_REQUEST['report']);
                checkStmt($stmt = $sql->execute());
                if ($z = $stmt->fetchObject()) $sortNr = $z->SortNr;
                else $sortNr = 99999;
                
                $sql = new SqlAbfrage('WSR');
                $sql->sql .= 'select SortNr from wsrReports';
                $sql->addSel('rolle = ', $_REQUEST['rolle']);
                $sql->addSel('reportTitle = ', $_REQUEST['ziel']);
                checkStmt($stmt = $sql->execute());
                if ($z = $stmt->fetchObject()) $sortNrZ = $z->SortNr;
                else {
                    echo "FEHLER: Ungültiges Ziel";
                    var_dump($_REQUEST);
                }
                
                if ($sortNrZ < $sortNr){
                    // nach oben verschoben
                    $sql = new SqlAbfrage('WSR');
                    $sql->sql = 'update wsrReports set SortNr = SortNr + 1 where SortNr >= '.$sortNrZ
                        .' and SortNr < '.$sortNr;
                    $sql->firstWhere = false;
                    $sql->addSel('rolle =',  $_REQUEST['rolle']);
                    $sql->execute();                    
                }else{
                    // nach unten verschoben
                    $sql = new SqlAbfrage('WSR');
                    $sql->sql = 'update wsrReports set SortNr = SortNr - 1 where SortNr > '.$sortNr
                        .' and SortNr <= '.$sortNrZ;
                    $sql->firstWhere = false;
                    $sql->addSel('rolle =',  $_REQUEST['rolle']);                    
                    $sql->execute();                    
                }
                
                if ($sortNr < 99999){
                    $sql = new SqlAbfrage('WSR');
                    $sql->sql = 'update wsrReports set SortNr = '.$sortNrZ;
                    $sql->addSel('rolle = ', $_REQUEST['rolle']);
                    $sql->addSel('reportTitle = ', $_REQUEST['report']);
                    $sql->execute();
                    
                }else{
                    $sql = new SqlAbfrage('WSR');
                    $sql->sql = 'insert into wsrReports set';
                    $sql->addKlausel('rolle = ', $_REQUEST['rolle']);
                    $sql->addKlausel(', reportTitle = ', $_REQUEST['report']);
                    $sql->addKlausel(', SortNr = ',$sortNrZ);
                    $sql->execute();                    
                }                
            }else var_dump($_REQUEST);
            break;
            
            
    }
}

?>
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>WSReporter: Rollenverwaltung</title>
<meta name="GENERATOR" content="WS-PHP: editRollen.php">
<link rel="stylesheet" href="./jscss/standard2.css">
<link rel="stylesheet" href="./jscss/editUser.css">
<script type="text/javascript" src="./jscss/editUser.js">
	</script>

</head>


<body>
<h1>WS-Reporter: Rollenverwaltung</h1>

<div class="inlineBox">
<h3>Rollen</h3>
<form action="./editRollen.php" method="post" id="form" >
<input type="hidden" name="action" value="" />
<input type="hidden" name="report" value="" />
<input type="hidden" name="ziel" value="" />
<?php 
if (array_key_exists('rolle', $_REQUEST)){
?>
<input type="hidden" name="rolle" value="<?= $_REQUEST['rolle'] ?>" />
<?php  
}else{
?>
<input type="hidden" name="rolle" value="" />
<?php  
}
if (array_key_exists('quelle', $_REQUEST)){
?>
<input type="hidden" name="quelle" value="<?= $_REQUEST['quelle'] ?>" />
<?php  
}else{
?>
<input type="hidden" name="quelle" value="" />
<?php  
}
?>
<table>
<?php
  $sql = new SqlAbfrage('WSR');
  $sql->sql = 'select rolle from wsrRollen order by rolle';
  $stmt = $sql->execute();
  if ($stmt === false){
      echo '</table>Beendet nach Fehler</body></html>';
      die();
  }
  while ($z = $stmt->fetchObject()){
?>      
<tr><th class='left'><?=$z->rolle ?></th>
<td onclick="delRolle('<?=$z->rolle ?>')" class="center"><?=iconDelete() ?></td>
<td onclick="selRolle('<?=$z->rolle ?>')" class="center"><?=iconSelect() ?></td>
</tr>
<?php 
  }
?>
<tr><td colspan='3' >Neu: <input type="text" size="50" onchange="neueRolle(this);return false"  /></td></tr>
</table>
</div>
<?php 
if (array_key_exists('rolle', $_REQUEST) && isValid($_REQUEST['rolle'])){
?>
<div class="inlineBox">
<h3>Datenquellen</h3>
<table>
<?php 
    $sql = new SqlAbfrage('WSR');
    $sql->sql = 'select count(*) as Anzahl from wsrUser';
    $sql->addSel('rolle = ',$_REQUEST['rolle']);
    $sql->addWhere(' adminRecht = 0');
    $stmt = $sql->execute();
    $z = $stmt->fetchObject();
    $anzahl = $z->Anzahl;
    
    $sql = new SqlAbfrage('WSR');
    if ($anzahl > 0){
        $sql->sql = 'select distinct table_name as datenquelle from wsrRechte where user in (select user from wsrUser';
        $sql->addSel('rolle = ',$_REQUEST['rolle']);
        $sql->sql .= ') order by datenquelle';
    }else {
        if (isset($compat0))
            $sql->sql = 'select distinct s.datenquelle from ('
            .'select table_name as datenquelle FROM `reportAttributes`'
            .' union select reportDef7 as datenquelle from reportDefinitionen where SatzTyp = 0' 
            .')s order by datenquelle ';
            else
        $sql->sql = 'select distinct table_name as datenquelle FROM `reportAttributes` order by datenquelle ';
    }
//    echo 'Select: '.$sql->sql;
    $stmt = $sql->execute();
    if ($stmt === false){
        echo "FEHLER bei select Datenquelle\n".$sql->errorInfo()[2];
        die();
    }
    while ($z = $stmt->fetchObject()){
?> 
<tr><td><input type="checkbox" onclick="selQuelle('<?=$z->datenquelle ?>')" /></td><td><?=$z->datenquelle ?></td></tr>

<?php         
    }
?>

</table>
</div>
<div class="inlineBox">
<h3>Zugordnete Reports</h3>
<h4>für <?=$_REQUEST['rolle'] ?></h4>
<table>
<thead>
<tr><th>Datenquelle</th><th>Report</th><th>&nbsp;</th><th colspan='3'>zuordnen</th></tr>
</thead>
<tbody>
<?php 
  $sql = new SqlAbfrage('WSR');
  
  $sql->sql = 'select d.datenquelle, d.reportTitle, ifnull(z.SortNr,99999) as SortNr  from ('
        .' select a.table_name as datenquelle, t.reportTitle_de as reportTitle'
        .' from reportAttributes a, reportTitle t where t.reportID = a.reportID';
  if (isset($compat0)){
       $sql->sql .= "\n union select reportDef7 as datenquelle, reportTitle FROM `reportDefinitionen`" 
               .' where SatzTyp = 0';
  }
  $sql->sql .= ') d';
  if (false){
      $sql->sql .= '  join wsrRechte r on r.table_name = d.datenquelle and r.user in (select user from wsrUser ';
      $sql->addSel('rolle = ',$_REQUEST['rolle']);
      $sql->sql .= ') ';
  }
  $sql->sql .= ' left join wsrReports z on z.reportTitle = d.reportTitle ';
  $sql->firstWhere = FALSE;
  $sql->addSel('rolle = ',$_REQUEST['rolle']);
  $sql->firstWhere = true;
  if (array_key_exists('quelle', $_REQUEST) && isValid($_REQUEST['quelle'])){
      $sql->addSel('z.SortNr is not null or d.datenquelle = ',$_REQUEST['quelle']);
  }
  $sql->sql .= ' ORDER BY SortNr, datenquelle, reportTitle';
//    echo '<pre>'.$sql->sql.'</pre>';
  $stmt = $sql->execute();
  if ($stmt === false){
      echo '</tbody></table>Beendet nach Fehler'.$sql->errorInfo()[2].'</body></html>';
      die();
  }
  while ($z = $stmt->fetchObject()){      
?>
<tr><th class = 'left'
<?php 
if ($z->SortNr < 99999){
    dragNDdrop(8, "'".$z->reportTitle."'", 'rollenDrop');
}else{
    drag(8,"'".$z->reportTitle."'", 'rollenDrop');
}
?>
 ><?=$z->datenquelle ?></th>
 <td 
 <?php 
if ($z->SortNr < 99999){
    dragNDdrop(8, "'".$z->reportTitle."'", 'rollenDrop');
}else{
    drag(8, "'".$z->reportTitle."'", 'rollenDrop');
}
?>
 ><?=$z->reportTitle ?></td>
<td onclick="outputReport('<?=$z->reportTitle ?>')" class="center"><?=iconOutput() ?></td>
<?php
if ($z->SortNr < 99999){  
?>
<td onclick="upReport('<?=$z->reportTitle ?>')" class="center"><?=iconUp() ?></td>
<td onclick="downReport('<?=$z->reportTitle ?>')" class="center"><?=iconDown() ?></td>
<td onclick="delReport('<?=$z->reportTitle ?>')" class="center"><?=iconDelete() ?></td>

<?php
}else{
?>
<td colspan='3'><button onclick="selReport('<?= $z->reportTitle ?>')" >zuordnen</button></td>
<?php
}
?>
</tr>
<?php
  }
?>

</tbody>
</table>
</div>
<?php 
}
?>
</form>
<form action = './outputReport.php' method='POST' target='TestOuput' id='outputForm'>
  <input type='hidden' name='report' />

</form>
</body>
</html>