<?php
/**
 * Projekt: WS-Reporter
 *          Massen-Import von Datenquellen, Reports und Übersetzungen
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    19.09.2022
 *
 * Hinweise:
 *
 */
include 'includes/defender.inc';
global $dbh, $query;
require_once './includes/funktionen.inc';
require_once './includes/classes.inc';
require_once './includes/wsrTranslate.inc';
if (session_status() == PHP_SESSION_NONE)  session_start();
anmeldungPruefen();
adminRechteVerlangen();

?>
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>WS-Reporter <?=WSRTranslate::translate('Importieren')?></title>
<meta name="GENERATOR" content="WS-PHP: importAll.php">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<link rel="stylesheet" href="./jscss/standard2.css">
<link rel="stylesheet" href="./jscss/tableFolder.css">
<script type="text/javascript" src="./jscss/translate.js">
	</script>
<script type="text/javascript" src="./jscss/tableHeader.js">
	</script>
<script type="text/javascript" src="./jscss/tableFolder.js">
	</script>
<script>
function showFiles(obj){
	var ausgabe = document.getElementById('Liste');
	ausgabe.innerHTML = '<?=WSRTranslate::translate('Ausgewählte Dateien')?>:';
	for (var i = 0; i < obj.files.length;i++){
		ausgabe.innerHTML += '<br>'+obj.files[i].name;
	}
}
function clearFiles(){
	var ausgabe = document.getElementById('Liste');
	ausgabe.innerHTML = '';
	ausgabe = document.getElementById('Ergebnis');
	if (ausgabe != null) ausgabe.innerHTML = '';	
}
</script>	
	
</head>
<?php 
if ($_SERVER["HTTP_HOST"] == "localhost:8898") echo '<body class="entwicklung">';
else echo '<body>';

?>
<h1><?=WSRTranslate::translateH('Importieren aus mehreren Dateien') ?></h1>
<div class='centerBox'>
<form action='./importAll.php' method='POST' enctype="multipart/form-data" >
<h4><?=WSRTranslate::translate('Import von')?> <?=WSRTranslate::translate('Datenquellen')?></h4>
<?=WSRTranslate::translate('Achtung: Die Reihenfolge der Imports kann nicht beeinflusst werden.')?><br>
<input type='hidden' name='quellen' value='Query' />
<?=WSRTranslate::translate('Dateien')?>: <input type="file" name="importFile[]" multiple onchange='showFiles(this)' />
 <input type="submit" name="submit" value="<?=WSRTranslate::translate('Dateien importieren')?>" />
</form>
<br>
<form action='./importAll.php' method='POST' enctype="multipart/form-data" >
<h4><?=WSRTranslate::translate('Import von')?> <?=WSRTranslate::translate('Reports')?></h4>
<input type='hidden' name='quellen' value='Report' />
<?=WSRTranslate::translate('Dateien')?>: <input type="file" name="importFile[]" multiple onchange='showFiles(this)'/>
 <input type="submit" name="submit" value="<?=WSRTranslate::translate('Dateien importieren')?>" />
<br> <input type="checkbox" name='bestaetigt' value='X'/> <?=WSRTranslate::translate('vorhandene Reports überschreiben')?>
</form>
<br>
<form action='./importTranslation.php' method='POST' target="Translation" enctype="multipart/form-data" 
onsubmit='clearFiles()'>
<h4><?=WSRTranslate::translate('Import von')?> <?=WSRTranslate::translate('Übersetzungen')?></h4>
<?=WSRTranslate::translate('Dateien')?>: <input type="file" name="importFile[]" multiple onchange='showFiles(this)'/>
 <input type="submit" name="submit" value="<?=WSRTranslate::translate('Dateien importieren')?>" />
</form>
<br>
</div>
<div id='Liste' class='centerBox'></div>
<?php 
if (!array_key_exists('submit', $_REQUEST)){
    echo '</body></html>';
    return;
}
echo '<div id="Ergebnis" class="centerBox">';
if ($_REQUEST['quellen'] == 'Query')
    echo '<p>'.WSRTranslate::translateH('Importiere').' '.WSRTranslate::translateH('Datenquellen');
else
    if ($_REQUEST['quellen'] == 'Report')
        echo '<p>'.WSRTranslate::translateH('Importiere').' '.WSRTranslate::translateH('Reports');
        
for ($fcount=0; $fcount < count($_FILES['importFile']['name']); $fcount ++){
    
    $importFileName = $_FILES['importFile']['name'][$fcount];
    $datei = fopen($_FILES['importFile']['tmp_name'][$fcount],'r');
    error_log ('Importiere '.$importFileName);
    echo '<br>'.$importFileName.' ';
    if ($_REQUEST['quellen'] == 'Query'){
        require_once 'includes/importClassDef.inc';
        importClassDef($datei);
        fclose($datei);
        require './includes/saveClassDef.inc';
    }
    if ($_REQUEST['quellen'] == 'Report'){
        require_once 'includes/importReportDef.inc';
//        $query = new Query('');        
        importReportDef($datei);
        fclose($datei);
        require './includes/saveReportDef.inc';
        
    }
    echo ' - '.WSRTranslate::translateH('Fertig');
}
echo '</div>';
?>
</body>
</html>