<?php
/**
 * Projekt: WS-Reporter
 *          Funktionen zur Spezifikation der Filter in Reports
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    6.7.2022  ms
 *
 */

require_once './includes/wsrTranslate.inc';

function listFilterOptions($options,$selected){
    if (isValid($selected)){
?>
                <option value=""><?=WSRTranslate::translate('nicht aktiv')?></option>
<?php
        }else{
?>
                <option value=""  selected  ><?=WSRTranslate::translate('nicht aktiv')?></option>
<?php            
    }
    for ($fi=0; $fi < count($options); $fi++){
        if ($options[$fi][0] == $selected){
?>
      <option value="<?=$options[$fi][0] ?>" selected><?=$options[$fi][1] ?></option>
<?php
        }else{
?>
      <option value="<?=$options[$fi][0] ?>" ><?=$options[$fi][1] ?></option>
<?php
            
        }
    }
}

function enterFilterSpec($wo,$pos,$name,$sel_von, $sel_bis){
    global $query;
    /*
    if (substr($name,1,1)==':' || substr($name,1,1)=='='){
        $rt = $query->repTables->get(substr($name,0,1));
        if ($rt != null)
            enterFilterSpecQuery($wo,$pos,substr($name,2),$sel_von, $sel_bis,$rt->query);            
    }
    else
    */        
    enterFilterSpecQuery($wo,$pos,$name,$sel_von, $sel_bis,$query);
}
        
/**
 * Teilmaske zum Setzen der Filterwerte aufbauen
 * @param string $wo Umgebung: DefaultFilter|Filter|AddFilter|Output|Form
 * @param int $pos Position inm Filter-Vector
 * @param string $name
 * @param string $sel_von
 * @param string $sel_bis
 * @param Query $query
 */
function enterFilterSpecQuery($wo,$pos,$name,$sel_von, $sel_bis, $query){
    echo "\n<!-- enterFilterSpec($wo,$pos,$name,$sel_von, $sel_bis) \n -->";
//    error_log('EnterFilterSpec '.$wo.' Pos: '.$pos.' für '.$name.' - '.substr($name,0,13).' ergibt '.(substr($name,0,13) == '#windowFilter'));
    if (substr($name,0,13) == '#windowFilter') {
        $filter = $query->repFilter->getPos($pos);
        if (false) $filter = new WindowFilter('');
        $metaRecord = $filter->getMetaRecord();
    }else{
        $metaRecord = $query->getReportMetaRecord($name);
//        echo "\n<!-- enterFilterSpecQuery MR-Name = ".$metaRecord->getName().' FTyp = '.$metaRecord->filterType." -->\n";
    }
    if ($metaRecord == null){
        echo WSRTranslate::translate('Fehler').": $name ".WSRTranslate::translate("hat keine Metadaten.");
        return;
    }
/* wird jetzt bei getReportMetaRecord() gemacht    
    if (strlen($name)>2 && (substr($name,1,1) == ':' || substr($name,1,1) == '='))
        $metaRecord->queryOfSelect = substr($name,0,1);
        else $metaRecord->queryOfSelect = 'base';
        */
    $options = $metaRecord->getSelectOptions(); // Array 0=value, 1= label
    
    if (MetaRecord::LIST == $metaRecord->filterType){
?>
     <select class="small" name="filter_<?=$name ?>" onchange="setFilterList('<?=$wo?>','<?=$pos?>',this)">
     
<?php
        if ($wo == "DefaultFilter"){
            echo WSRTranslate::translate('List-Filter sind als Default-Filter nicht möglich');
            return;
        }
        else
            if ($wo == "Filter")
             $repFilter = $query->repFilter->getPos($pos);
        else 
            if ($wo == "AddFilter")
                $repFilter = $query->addFilter->getPos($pos);
                //     $repFilter = new RepFilter("hh");
        if (!isset($repFilter)){
            error_log('repFilter nicht gefunden wo='.$wo.' pos='.$pos.' name='.$name);
            echo ('repFilter nicht gefunden wo='.$wo.' pos='.$pos.' name='.$name);
            return;
        }
         if ($repFilter->fs_list == null || count($repFilter->fs_list) == 0 ){
            ?>
         <option value="" selected ><?=WSRTranslate::translate('nicht aktiv')?></option>
         <option value="bearbeiten" ><?=WSRTranslate::translate('erstellen')?></option>
<?php
        }else{
?>
         <option value="" selected><?=WSRTranslate::translate('gesetzt')?></option>
         <option value="bearbeiten" ><?=WSRTranslate::translate('bearbeiten')?></option>
         <option value="löschen"><?=WSRTranslate::translate('löschen')?></option>
<?php
       }
     
?>
     </select>
<?php
    }else   //  if (MetaRecord::LIST == $metaRecord->filterType)
    if (MetaRecord::SELECT == $metaRecord->filterType){
            ?>
     <select class="small" name="filter_<?=$name ?>" onchange="setPosAttribute('<?=$wo?>',<?=$pos?>,'fs_von',this.value)">
<?php
     listFilterOptions($options, $sel_von);   
?>
     </select>
<?php
    }else
        if (MetaRecord::HISTDEL == $metaRecord->filterType){
            ?>
     <select class="small" name="filter_<?=$name ?>" onchange="setPosAttribute('<?=$wo?>',<?=$pos?>,'fs_von',this.value)">
<?php
     listFilterOptions($options, $sel_von);   
?>
     </select>
<?php
    }else
    if (MetaRecord::VON_BIS_SELECT== $metaRecord->filterType){
?>
    <?=WSRTranslate::translate('von')?> <select class="small" name="filter_ab_<?=$name ?>" 
    		onchange="setPosAttribute('<?=$wo?>',<?=$pos?>,'fs_von',this.value)">
<?php
     listFilterOptions($options, $sel_von);   
?>
    </select>
    <?=WSRTranslate::translate('bis')?> <select class="small" name="filter_bis_<?=$name ?>" 
    		onchange="setPosAttribute('<?=$wo?>',<?=$pos?>,'fs_bis',this.value)">
<?php
     listFilterOptions($options, $sel_bis);   
?>
     </select>
<?php
   }else
   if (MetaRecord::TEXT== $metaRecord->filterType
       || MetaRecord::TEXTEXAKT== $metaRecord->filterType
       || MetaRecord::TEXTLIKE== $metaRecord->filterType){
               ?>
     <input class="small" type="text" name="filter_<?=$name ?>" 
     		onchange="setPosAttribute('<?=$wo?>',<?=$pos?>,'fs_von',this.value)"
            value = "<?=$metaRecord->formatValue($sel_von) ?>">
<?php
   }else
       if ( MetaRecord::TEXTMITLABEL== $metaRecord->filterType){
               ?>
     <input class="small" type="text" name="filter_<?=$name ?>" 
     		onchange="setPosAttribute('<?=$wo?>',<?=$pos?>,'fs_von',this.value)"
            value = "<?=$metaRecord->formatValue($sel_von) ?>"
            title = "<?=WSRTranslate::translate('Internen Code eingeben, z.B. Personalnummer statt Name')?>" >
<?php
   }else
     if (MetaRecord::VON_BIS== $metaRecord->filterType){
?>
	<?=WSRTranslate::translate('von')?>      <input class="small" type="text" name="filter_<?=$name ?>" 
     		onchange="setPosAttribute('<?=$wo?>',<?=$pos?>,'fs_von',this.value)"
            value = "<?=$metaRecord->formatValue($sel_von) ?>">
	<?=WSRTranslate::translate('bis')?>      <input class="small" type="text" name="filter_<?=$name ?>" 
     		onchange="setPosAttribute('<?=$wo?>',<?=$pos?>,'fs_bis',this.value)"
            value = "<?=$metaRecord->formatValue($sel_bis) ?>">
 <?php
     }else
      if (MetaRecord::SONDERFILTER== $metaRecord->filterType){
      // nur den Filternamen anzeigen
     }else
     if (MetaRecord::WINDOWFILTER== $metaRecord->filterType && isSet($filter)){
       
 ?>
		 <?=WSRTranslate::translate('für Wert')?> 
         <select onchange="setPosAttribute('<?=$wo?>',<?=$pos?>,'wfWert',this.value)" 
        name="filter_<?=$pos?>_2" id="filter_<?=$pos?>_2">
     <option value="" <?php if (!isValid($filter->getWert())) echo ' selected ';?>> <?=WSRTranslate::translate('nicht aktiv')?> </option>          
         <?php 
         $qVals = $query->repValues;
         if ($qVals != null){
             for ($wfi = 0; $wfi < $qVals->size();$wfi++){
                 $name = $qVals->getPos($wfi)->getName();
                 $metaRecordV = $query->getReportMetaRecord($name);
                if ($metaRecordV != null){
                    $label = $metaRecordV->label;
                    if (substr($name, 1,1) == '='
                        || substr($name, 1,1) == ':') $label = substr($name, 0,2).$label;
                    
?>
     <option value="<?=$name ?>" <?=checkSel($name,$filter->getWert())?> ><?=$label?></option>          
<?php 
                 }
            }
         }
         if (isValid($filter->getWert()))
             $metaRecordV = $query->getReportMetaRecord($filter->getWert());
         else $metaRecordV = null;
 ?>
         </select>
         <?php if (! $filter->isSortFilter() && $wo != 'Output' && $wo != 'Form'){ ?>
                     &nbsp;&nbsp;&nbsp;Ebene:
            <select  onchange="setPosAttribute('<?=$wo?>',<?=$pos?>,'abSpalte',this.value)" class="small" >
            <option value="0" <?=checkSel("0", $filter->abSpalte) ?> >!!FEHLT</option>
            <?php
            $qRows = $query->repRows;
            if ($qRows != null){
                for ($j = 0; $j < $qRows->size()-1; $j++){
                    if ( ! $qRows->getPos($j)->webLinkColumn){
                    $mr = $query->metaData[$qRows->getPos($j)->getName()];
                    
                    /// ALLES FALSCH ??
                    ?>
                    <option value="<?=$j+1 ?>" <?=checkSel($j+1, $filter->abSpalte) ?> ><?=$mr->label?></option>
                    <?php
                    }
                }
            }
         ?>
		</select>         
         <?php echo '  ('.$filter->abSpalte.')'; }?>  <br>
         <?php 
         
         switch ($filter->getType()){
             case WindowFilter::SUM:
                 echo '<span class="help" title = "'.WSRTranslate::translate('ggf Tsd.-Punkte und &lt; für kleiner').'">'
                        .WSRTranslate::translate('Summe').'</span>';
                        if ($metaRecordV != null)
                        if (isValid($sel_von) && substr($sel_von,0,1) == '<')
                            $sel_von = '< '.$metaRecordV->formatValue(substr($sel_von, 1));
                            else $sel_von = $metaRecordV->formatValue($sel_von);
                 break;
             case WindowFilter::KSUM:
                 echo '<span class="help" title = "'.WSRTranslate::translate('Summen-Grenze').'">'
                    .WSRTranslate::translate('Summe').'</span>';
                    if ($metaRecordV != null)
                         $sel_von = $metaRecordV->formatValue($sel_von);
                   break;
             case WindowFilter::ASUM:
                 echo '<span class="help" title = "'.WSRTranslate::translate('Summen-Anteil in % (0 - 100)').'">'
                    .WSRTranslate::translate('Summe in %').'</span>';
            break;
             case WindowFilter::RANG:
                 echo '<span class="help" title = "'.WSRTranslate::translate('Anzahl der max. anzuzeigenden Zeilen').'">'
                    .WSRTranslate::translate('Anzahl').'</span>';
                 break;
             case WindowFilter::PCTRANG:
                 echo '<span class="help" title = "'.WSRTranslate::translate('Anteil in % (0 - 100)').'">'
                    .WSRTranslate::translate('Anteil').'</span>';
                 break;
             case WindowFilter::NTILE:
                 echo '<span class="help" title = "'.WSRTranslate::translate('Beispiel: 1/4 = 25%, mind. 1 Zeile').'">'
                    .WSRTranslate::translate('Anteil').'</span>';
                 break;
         }
         ?>
         <input class="small" type="text" name="filter_<?=$pos ?>"
         onchange="setPosAttribute('<?=$wo?>',<?=$pos?>,'fs_von',this.value)"
         value = "<?=$sel_von ?>">
         <input type="checkbox" name="filter_<?=$pos?>_3" id="filter_<?=$pos?>_3"
         <?php if (! $filter->getDesc()) echo ' checked ';?>
         onchange="setPosAttribute('<?=$wo?>',<?=$pos?>,'wfAsc',this.checked)"> <?=WSRTranslate::translate('aufsteigend')?>

         <br><?=WSRTranslate::translate('Typ ändern')?>:
         <select onchange="setPosAttribute('<?=$wo?>',<?=$pos?>,'wfType',this.value)" 
        name="filter_<?=$pos?>_1" id="filter_<?=$pos?>_1">
<?php
foreach (WindowFilter::klartext as $t => $kt){
?>
<option value='<?=$t ?>' <?= checkSelN($t, $filter->getType())?> ><?=$kt ?></option>
<?php 
}
?>
</select>         
         
 <?php
     }else
      if (MetaRecord::SONDERFILTERSEL== $metaRecord->filterType){
?>
 <select class="small" name="filter_ab_<?=$name ?>" 
    		onchange="setPosAttribute('<?=$wo?>',<?=$pos?>,'fs_von',this.value)">
<?php         
        if (isValid($sel_von)){
?>
                <option value=""><?=WSRTranslate::translate('nicht aktiv')?></option>
<?php
        }else{
?>
                <option value=""  selected  ><?=WSRTranslate::translate('nicht aktiv')?></option>
<?php            
        }
        for ($fi=0; $fi < count($options); $fi++){
            if ($options[$fi][0] == $sel_von){
?>
          <option value="<?=$options[$fi][0] ?>" selected><?=$options[$fi][0] ?></option>
<?php
        }else{
?>
          <option value="<?=$options[$fi][0] ?>" ><?=$options[$fi][0] ?></option>
<?php
                
            }
        }
     echo '</select>';
     }else{
?>
Unbekannter  Filter-Typ: <?=$metaRecord->filterType?>
<?php
    }
}

function listFilter($selected){
    global $query;
    listFilterQuery($selected, $query);
}
function listFilterQuery($selected, $query){
    listFilterQueryP($selected, $query,'',true);
}

function listFilterQueryC($selected, $query){
    listFilterQueryP($selected, $query,'',false);
}


function listFilterQueryP($selected, $fquery, $pref,$showValueFilter){
    global $query;
    $addFilter = ($selected == '-AddFilter');
    if ($addFilter) $muster = $query->addFilterMuster;
        else  $muster = $query->repFilterMuster;
        
    echo '<option value="" >--</option>';
    if ($fquery->rowVars != null)
        for ($i=0; $i < count($fquery->rowVars); $i++){
            $name = $fquery->rowVars[$i];            
            if ($query->repFilter == null
                || ( ! $query->repFilter->has($pref.$name) && ! $addFilter)
                || ( ! $query->addFilter->has($pref.$name) && $addFilter)
                ){
                    $metaRecord = $fquery->metaData[$name];
                    if ($metaRecord == null) echo WSRTranslate::translate('FEHLER').': '.$name.' '
                        .WSRTranslate::translate('hat keine Metadaten');
                else if ($metaRecord->filterType > 0){
                    $sel = "";
                    if ($selected == $name ) $sel = " selected ";
                    if (!isValid($muster) || (stripos($metaRecord->label, trim($muster)) !== false))
                        if (! $metaRecord->hidden){
                    ?>
 <option value="<?=$pref.$name ?>" <?=$sel?> <?=makeTitle($metaRecord->description)?>><?=$pref.$metaRecord->label?></option>
<?php
                    }
                    }
            }
    }
    if ($fquery->valueVars != null)
        for ($i=0; $i < count($fquery->valueVars); $i++){
            $name = $fquery->valueVars[$i];
            if ($query->repFilter == null
                || ( ! $query->repFilter->has($pref.$name) && ! $addFilter)
                || ( ! $query->addFilter->has($pref.$name) && $addFilter)
                ){
                    $metaRecord = $fquery->metaData[$name];
                    if ($metaRecord == null) echo WSRTranslate::translate('FEHLER').': '.$name.' '
                    .WSRTranslate::translate('hat keine Metadaten');
                else if ($metaRecord->filterType > 0){
                    $sel = "";
                    if ($selected == $name ) $sel = " selected ";
                    if ($metaRecord->filterType == MetaRecord::SONDERFILTER
                        || $metaRecord->filterType == MetaRecord::SONDERFILTERSEL) $star='';
                    else if ($showValueFilter) $star = '* ';
                    else continue;
                    if (!isValid($muster) || (stripos($metaRecord->label, trim($muster)) !== false))
                        if (! $metaRecord->hidden){
                    ?>
 <option value="<?=$pref.$name ?>"  <?=$sel?>  <?=makeTitle($metaRecord->description)?>><?=$star.$pref.$metaRecord->label?></option>
<?php
                    }
                }
            }
    }
    if ($fquery->filterVars != null)
        for ($i=0; $i < count($fquery->filterVars); $i++){
            $name = $fquery->filterVars[$i];
            if ($query->repFilter == null 
                || ( ! $query->repFilter->has($pref.$name) && ! $addFilter)
                || ( ! $query->addFilter->has($pref.$name) && $addFilter)
                ){
                $metaRecord = $fquery->metaData[$name];
                if ($pref == '' && $metaRecord->baseFilter()) continue;
                if ($metaRecord == null) echo WSRTranslate::translate('FEHLER').': '.$name.' '
                    .WSRTranslate::translate('hat keine Metadaten');
                else if ($metaRecord->filterType > 0){
                    $sel = "";
                    if ($selected == $name ) $sel = " selected ";
                    if ($metaRecord->filterType == MetaRecord::WINDOWFILTER) $star='* ';
                        else $star = '';
                    if (!isValid($muster) || (stripos($metaRecord->label, trim($muster)) !== false))
                        if (! $metaRecord->hidden){
                    ?>
 <option value="<?=$pref.$name ?>"  <?=$sel?>  <?=makeTitle($metaRecord->description)?>><?=$star.$pref.$metaRecord->label?></option>
<?php
                    }
                }
            }
    }
}
?>

