<?php 
/**
 * Projekt: WS-Reporter
 *          Anzeige der Zeilen bei der Spezifikation der Datenquellen
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    22.02.2023
 *
 */
require_once './includes/wsrTranslate.inc';
global $query;
?>
<table>
<tr><td><?=WSRTranslate::translateH('Name')?></td>
<td class = "center"><?=WSRTranslate::translateH('Zum Bearbeiten auf das Label klicken')?></td>
<td colspan=2><?=WSRTranslate::translateH('Bewegen')?></td><td><?=WSRTranslate::translateH('löschen')?></td></tr>
<?php 
for ($i = 0; $i < count($query->rowVars); $i++){
 $mr = $query->getMetaRecord(1,$i);
?>
<tr  class="draggable" 
<?php dragNDdrop(1,$i,'drop')?>
><th class="left" onclick="editVar(1,<?=$i ?>)"
  <?=makeTitle($mr->description) ?>><?=$query->rowVars[$i] ?></th>
<td onclick="editVar(1,<?=$i ?>)"><?=quoteForText($mr->label) ?></td>
<td onclick="moveUp(1,<?=$i ?>)" class="center"><?=iconUp() ?></td>
<td onclick="moveDown(1,<?=$i ?>)" class="center" ><?=iconDown() ?></td>
<td onclick="delVar(1,<?=$i ?>)" class="center"><?=iconDelete() ?></td>
</tr>
<?php 
}
if ($query->queryType == Query::DIMENSION){    
    ?>
<tr><th class="left" 
<?=makeTitle(WSRTranslate::translateH('Key-Variable zum Verknüpfen auswählen')) ?>
  ><?=WSRTranslate::translateH('Key für Verknüpfung')?></th>
<td>
  <select  onchange="setAttrib('dimKey',this.value)">
  <option value="" >---</option>
<?php 
for ($i = 0; $i < count($query->rowVars); $i++){
    $mr = $query->getMetaRecord(1,$i);    
    echo '<option value="'.$mr->getName(),'" '.checkSel($mr->getName(),$query->dimKey).' >'.$mr->getName()."</option>\n";
}
?>  
</select> 



</td>
<td>&nbsp;</td>
<td>&nbsp;</td>
<td>&nbsp;</td>
</tr>
<?php     
}
?>
<tr><th class="left"><?=WSRTranslate::translateH('Neue Variable')?></th>
<td title="<?=WSRTranslate::translate('Auswahlliste bei Muster mit ?')?>"
 ><?=WSRTranslate::translateH('hier eintragen')?>
  <input type="text" onchange="newVar(1,this)" id="NV1" size="30" autocomplete="off"/>
</td><td></td><td></td></tr>

</table>
<?php
 if ($query->showMuster == 1){
	$liste = $query->listMuster();
	echo WSRTranslate::translate('Muster (ggf. anklicken)').':<br><table>';
	 foreach ($liste as $name => $label){
	     ?>
<tr <?=makeTitle($label[1])?>><th class="left" onclick="newMusterVar(1,'<?=$name ?>')"><?=$name ?></th>
<td onclick="newMusterVar(1,'<?=$name ?>')"><?=$label[0] ?></td></tr>
	 <?php
	 }
	 ?>
	 <tr><th></th>
	 <th onclick="closeMuster(1)" > <?=$query->showMuster?> <?=WSRTranslate::translate('schließen')?></th></tr>
	 </table>	 
	 <?php
 }	 
?>
