<?php
/**
 * Projekt: WS-Reporter
 *          Objekte in Listen verschieben und löschen bei der Spezifikation der Datenquellen
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    22.02.2023 MS
 *
 */
require_once './includes/wsrTranslate.inc';

// error_log(print_r($_REQUEST,true));

$action =$_REQUEST['action'];
$pos =$_REQUEST['pos'];
$wo =$_REQUEST['wo'];

if (false) $query = new Query("d");
$arr = null;
$vec = null;
$aq = null;
$meta = null;
if (false) $vec = new Vector();

switch($wo){
    case 1: $arr = &$query->rowVars;
            $meta = &$query->metaData;
    break;
    case 2: $arr = &$query->valueVars;
            $meta = &$query->metaData;
    break;
    case 3: $arr = &$query->filterVars;
            $meta = &$query->metaData;
//            error_log('filterVars:'.print_r($arr,true));
    break;
    case 4: $vec = &$query->addQueries;
            if (strcmp($action, "moveTo") ==  0){
                $nach = $_REQUEST['nachPos'];
                $vec->movePos($pos,$nach);
                return;
            }
            $meta = &$query->metaData;            
    break;
    case 5: $vec = &$query->dimensions;
            $meta = &$query->metaData;
            if (strcmp($action, "delete") ==  0){               
                unset ($vec[$pos]);
                foreach ($meta as $name => $mr){
//                    $mr = new MetaRecord();
                    if ($mr->dimNr == $pos){
                        unset($meta[$name]);
                        if (false !== $p=array_search($name, $query->rowVars)) unset($query->rowVars[$p]); 
                        if (false !== $p=array_search($name, $query->filterVars)) unset($query->filterVars[$p]);                        
                    }
                    
                }
                $rv = array();
                foreach ($query->rowVars as $v) $rv[] = $v;
                $query->rowVars = $rv;
                $fv = array();
                foreach ($query->filterVars as $v) $fv[] = $v;
                $query->filterVars = $fv;                
            }
            if (strcmp($action, "initDimension") ==  0){
                if ($_REQUEST['init'] == "Standard") $vec[$pos]->initSimpleDim();
                else $vec[$pos]->dimType = Dimension::ADDEDDIM;                
            }
            if (strcmp($action, "initDimensionKey") ==  0){
                $vec[$pos]->initAddedDim($_REQUEST['key']);
            }
            return;    
    break;
    case 6: $arr = &$query->defaultFilter;
            $meta = &$query->metaData;
    break;
    case 100: if ($query->qEditSubject >= 100){
        $p = $query->qEditSubject -100;
        $aq = $query->addQueries->getPos($p);
        if ($aq != null){
            $arr = &$aq->calcVars;            
            $meta = &$aq->getQuery()->metaData;
        }
    }
    break;
}

/*
echo "Test-Aufruf $wo $action:\n";
echo var_dump($_REQUEST);
echo var_dump($arr);
*/
if ($arr === null) error_log('$arr ist null:'.print_r($arr,true)."\ņ".print_r($query,true));
if ($arr !== null && $action == 'selectDimVar'){
    $sql = new SqlAbfrage('WSR');
    $sql->sql = 'select * from queryColumnMetadata';
    $sql->addSel('table_name = ', $query->dimensions[$query->selectedDimension]->dimName);
    $sql->addSel('SpaltenTyp = ', $wo);
    $sql->addSel('SortNr = ', $pos);
    $stmt = $sql->execute();
    if ($z = $stmt->fetchObject()){
        $mr = new MetaRecord();
        $mr->fillFrom($z,$query);
        $mr->readSelections(); //  getSelectOptions();
//        error_log(print_r($mr,true));
        $query->dimensions[$query->selectedDimension]->insertVar($mr,$wo,-2);
    }else{
        http_response_code(425);
        echo "Metadaten nicht gefunden\n".$sql->sql;
        die();
    }
    return;
}

if ($arr != null && $pos >= 0 && $pos < count($arr)){
    if (strcmp($action, "delete") ==  0){
        $n = $arr[$pos];       
        if ($wo != 6) unset ($meta[$n]);
        for ($i = $pos; $i < (count($arr) -1); $i++){
            $arr[$i] = $arr[$i +1];            
        }
        unset($arr[count($arr)-1]);        
        return;
    }
    if (strcmp($action, "moveUp") ==  0){
        if ($pos <= 0) return;
        $t = $arr[$pos];
        $arr[$pos] = $arr[$pos -1];
        $arr[$pos-1] = $t;
        echo "moveUp\n".var_dump($arr);
        return;
    }
    if (strcmp($action, "moveDown") ==  0){
        if ($pos >= count($arr) -1) return;
        $t = $arr[$pos];
        $arr[$pos] = $arr[$pos +1];
        $arr[$pos+1] = $t;
        return;
    }
    if (strcmp($action, "moveTo") ==  0){
        $nachWo = $_REQUEST['nachWo'];
        if ($wo != $nachWo){
            http_response_code(425);
            echo WSRTranslate::translate('Verschieben zwischen Kategorien (noch) nicht möglich');
            die();
        }
        $nachPos = $_REQUEST['nachPos'];
//        if ($pos >= count($arr) -1) return;
        $t = $arr[$pos];
        if ($pos > $nachPos){
            for ($i = $pos; $i > $nachPos; $i--) $arr[$i] = $arr[$i -1];
        }else for ($i = $pos; $i < $nachPos; $i++) $arr[$i] = $arr[$i +1];
        $arr[$nachPos] = $t;
        return;
    }
    if (strcmp($action, "editVar") ==  0){
        $query->qEditSubject = $wo;
        $query->qEditVar = $arr[$pos];
//        echo "$query->class_table : $query->qEditSubject $query->qEditVar";
        return;
    }
    if (strcmp($action, "defaultFilter") ==  0 && $wo = 6){
        $df = $query->defaultFilter[$pos];
        if ($df == null){
            http_response_code(425);
            echo WSRTranslate::translate('Default-Filter an Position').' '
                .$pos.' '.WSRTranslate::translate('nicht gefunden');
            die();
        }
        $mr = $query->getReportMetaRecord($df->getName());
        if (isValid($_REQUEST['wert'])) $wert = $mr->reformatValue($_REQUEST['wert']);
        else $wert = $_REQUEST['wert'];
        if ($_REQUEST['was'] = 'fs_von')  $df->fs_von = $wert;
        if ($_REQUEST['was'] = 'fs_bis')  $df->fs_bis = $wert;
        
        //        echo "$query->class_table : $query->qEditSubject $query->qEditVar";
    //        error_log (print_r($query->defaultFilter[$pos],true));
    //    error_log (print_r($_REQUEST,true));
        return;
    }
}

if ($vec != null){
    if (strcmp($action, "delete") ==  0){
        $vec->removePos($pos);
        return;
    }
    if (strcmp($action, "moveUp") ==  0){
        $vec->upPos($pos);
        return;
    }
    if (strcmp($action, "moveDown") ==  0){
        $vec->downPos($pos);
        return;
    }
    
}

http_response_code(425);
echo "ungüliger Aufruf:\n";
echo var_dump($_REQUEST);