<?php
/**
 * Projekt: WS-Reporter
 *          Globale Attribute bei der Spezifikation der Datenquellen
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    22.02.2023 MS
 *
 */
require_once './includes/wsrTranslate.inc';
global $query;

$attrib = $_REQUEST['attribute'];
$value = trim($_REQUEST['value']);
switch ($attrib) {
    case "defaultTitle":
        $query->defaultTitle = $value;
        return;
    
    case "outputTitlePrefix":
        $query->outputTitlePrefix = $value;
        return;
    
    case "reportCSS":
        $query->reportCSS = $value;
        return;
    
    case "reportHoverMode":
        $query->reportHoverMode = 1*$value;
        return;
    
    case "phys_table":
        $query->phys_table = $value;
        return;
    
    case "dwh":
        $query->dwh = $value;
        return;
    
    case "dimKey":
        $query->dimKey = $value;
        return;
    
    case "queryType":
        $query->queryType = $value;
        return;
    
    case "historyOption":
        $query->historyOption = 1*$value;
        return;
    
    case "historyDate":
        $vd = WSRFormats::stdDate($value);
        $query->historyDate = $vd;
        return;
    
    case "hatWerteAuswahl":
        if ($value == 'true'){
            $query->hatWerteAuswahl = true;
            $mr = new MetaRecord();
            $mr->init($query->class_table, 'WSR_WERTELISTE');
            $mr->filterType = MetaRecord::WERTELISTE;
            $mr->description = WSRTranslate::translate('Werte im Report ersetzen.')
                ."\n".WSRTranslate::translate('Hier Wert auswählen.');
            $mr->label = 'Werte';        
            $query->metaData['WSR_WERTELISTE'] = $mr;
        }
        else {
            $query->hatWerteAuswahl = false;
            unset($query->metaData['WSR_WERTELISTE']);
        }
        return;
    
    case "histType":
        $query->histType = 1*$value;
        if ($value == Query::KEINE){
            $query->histAb = null;
            $query->histBis = null;
            $query->histStichtag = null;
        }else
            if ($value == Query::VONBIS){
    //            $query->histStichtag = null;
        }else
            if ($value == Query::STICHTAG 
                || $value == Query::STICHTAGE){
                $query->histAb = null;
                $query->histBis = null;
        }else
            error_log('Hist-Type = '.$query->histType);
        return;
    
    
    case "table_description":
        if (isValid($value)){
            $query->table_description = $value;
        }
        else $query->table_description ="";
        return;

    case "table_hints":
        if (isValid($value)){
            $query->table_hints = $value;
        }
        else $query->table_hints ="";
        return;
        
    case "muster_tabelle":
        $query->muster_tabelle = $value;
        return;
    
    case 'translation_de':
        if ($_REQUEST['value'] == 'true' and false === array_search('de', $query->qTranslations) ) $query->qTranslations[] = 'de';
        if ($_REQUEST['value'] == 'false' and false !== array_search('de', $query->qTranslations) )
            unset($query->qTranslations[array_search('de', $query->qTranslations)]);
        return;
    
    case 'translation_en':
        if ($_REQUEST['value'] == 'true' and false === array_search('en', $query->qTranslations) ) $query->qTranslations[] = 'en';
        if ($_REQUEST['value'] == 'false' and false !== array_search('en', $query->qTranslations) )
            unset($query->qTranslations[array_search('de', $query->qTranslations)]);
        return;
    
    case 'translation_fr':
        if ($_REQUEST['value'] == 'true' and false === array_search('fr', $query->qTranslations) ) $query->qTranslations[] = 'fr';
        if ($_REQUEST['value'] == 'false' and false !== array_search('fr', $query->qTranslations) )
            unset($query->qTranslations[array_search('fr', $query->qTranslations)]);
        return;
}


http_response_code(425);
echo "setAttrib: Unbekanntes Query-Attribut: $attrib";
return;

