<?php
/**
 * Projekt: WS-Reporter
 *          Ausgabe der History-Einstellungen des Report-Editors
 *          Für jede Quelle und jede Dimension kann hier der Stichtag
 *          für das Gültigkeitsintervall eingestellt werden.
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    22.6.2022 ms
 *
 */
global $query;

$c = 0;
$tc = 0;
if ($query->histType > 0) {
    $cl = "nowrap ";
    $c++;
    if ($query->historyOption == HistoryOptions::HSDATUM && isValid($query->historyDate)) 
        $hDatum =  WSRFormats::formatDate(DateTime::createFromFormat('Y-m-d',$query->historyDate));
    else $hDatum = '';
    ?>
            <div class="<?=$cl ?> top" >
            <div class="inlineBlock">
       
<span class="help" title="<?=WSRTranslate::translate("Voreinstellung für alle Quellen und Dimensionen,
ohne eigene Spezifikation")?>"            
            ><b><?=WSRTranslate::translate("Basisquelle")?></b> (<?=WSRTranslate::translate("Hist.")?>:  <?=Query::getHistText($query->histType)?>)
<select onchange="setHistOption(<?= $tc ?>,0,this.value)">
<option value='0' <?=checkSelN($query->historyOption, 0) ?>>&nbsp;</option>
<?php
for ($i = 1; $i <= 7; $i++)
  if (($i != HistoryOptions::HSSTICHTAGSELBST 
      && $i != HistoryOptions::HSSTICHTAGBASE)
      || isValid($query->histStichtag))
    if (($i == HistoryOptions::HSSTICHTAGSELBST
        || $i == HistoryOptions::HSSTICHTAGBASE)
        && ($query->histType != Query::STICHTAG))
    {
 ?>
<option value='<?= $i ?>' <?=checkSelN($query->historyOption, $i) ?>
class='red' title='<?=WSRTranslate::translate("ACHTUNG: Mehrere Stichtage führen zu Doppel-Zählungen,
wenn der Stichtag keine Zeile oder Spalte im Report ist.")?>'><?=HistoryOptions::getKlartext($i) ?> *??</option>
<?php 
      }else    {
          ?>
<option value='<?= $i ?>' <?=checkSelN($query->historyOption, $i) ?>><?=HistoryOptions::getKlartext($i) ?></option>
<?php 
}
    
?>
</select></span>
<span id='HistDate<?= $tc ?>.0' <?php if ($query->historyOption != 6) echo 'class="hidden"' ?>><?=WSRTranslate::translate("Datum")?>: 
<input onchange="setHistDatum(<?= $tc ?>,0,this.value)" size="13" value="<?=$hDatum ?>" /></span>            
<div class="lw"><b><?=WSRTranslate::translate("Dimensionen")?>:</b>
<?php
}else{
    ?>
<div class="<?=$cl ?> top" >
<div class="inlineBlock">
<div class="lw"><b><?=WSRTranslate::translate("Dimensionen")?>:</b>
<?php     
}
foreach($query->dimensions as $nr => $dim){
    if (false) $dim = new Dimension(null);
    if ($dim->histType > 0){
        if (! $query->reportHasDim('base', $nr)) continue;
        if ($dim->historyOption == HistoryOptions::HSDATUM && isValid($dim->historyDate))
            $hDatum =  WSRFormats::formatDate(DateTime::createFromFormat('Y-m-d',$dim->historyDate));
            else $hDatum = '';
            ?>
<br>&nbsp;&nbsp;
<?=$dim->dimName.' ('.WSRTranslate::translate("Hist").': '.Query::getHistText($dim->histType)?>) 
<select onchange="setHistOption(<?= $tc ?>,<?=$dim->dimNr ?>,this.value)">
<option value='0' <?=checkSelN($dim->historyOption, 0) ?>>&nbsp;</option>
<?php
for ($i = 1; $i <= 7; $i++){
?>
<option value='<?= $i ?>' <?=checkSelN($dim->historyOption, $i) ?>><?=HistoryOptions::getKlartext($i) ?></option>
<?php
}
?>
</select>
<span id='HistDate<?= $tc ?>.<?=$dim->dimNr ?>' <?php if ($dim->historyOption != 6) echo 'class="hidden"' ?>
><?=WSRTranslate::translate("Datum")?>: 
<input onchange="setHistDatum(<?= $tc ?>,<?=$dim->dimNr ?>,this.value)" size="13" value="<?=$hDatum ?>" /> </span>
<?php
    } // if histType > 0
} // Ende Schleife Dimension
    
?>
</div>        
<br>
</div></div>    
<?php

// ENDE Basiquelle

for ($tc = 1; $tc <= $query->repTables->size(); $tc++){
   
    $repTable = $query->repTables->getPos($tc-1);
    if (false) $repTable = new JoinedTable(null);
    $tQuery = $repTable->query;
    
    if ($tQuery->histType == 0) continue;
    $cl = "nowrap ";
    $c++;
//    if ($c % 2 == 0) $cl .= " lw";
    if ($repTable->dimHistoryOption[0] == HistoryOptions::HSDATUM && isValid($repTable->dimHistoryDate[0]))
        $hDatum =  WSRFormats::formatDate(DateTime::createFromFormat('Y-m-d',$repTable->dimHistoryDate[0]));
        else $hDatum = '';
        ?>
            <div class="<?=$cl ?> top" >
            <div class="inlineBlock">
    <span class="help" title="<?=WSRTranslate::translate("Abweichende Auswahl für diese Quelle
und Voreinstellung für alle Dimensionen dieser Quelle,
ohne eigene Spezifikation")?>"
     ><b><?=$tQuery->class_table.' '.$repTable->kennzeichen ?></b> <?=$repTable->prefix.' ('
        .WSRTranslate::translate("Hist.").': '.Query::getHistText($tQuery->histType)?>)
       
<select onchange="setHistOption(<?= $tc ?>,0,this.value)">
<option value='0' <?=checkSelN($repTable->dimHistoryOption[0], 0) ?>>&nbsp;</option>
<?php
for ($i = 1; $i <= 7; $i++)
    if (($i != HistoryOptions::HSSTICHTAGSELBST)
        || isValid($tQuery->histStichtag))
            if ($i == HistoryOptions::HSSTICHTAGSELBST
                && ($tQuery->histType != Query::STICHTAG))
            {
                ?>
<option value='<?= $i ?>' <?=checkSelN($repTable->dimHistoryOption[0], $i) ?>
class='red' title='<?=WSRTranslate::translate("ACHTUNG: Mehrere Stichtage führen zu Doppel-Zählungen,
wenn der Stichtag keine Zeile oder Spalte im Report ist.")?>'><?=HistoryOptions::getKlartext($i) ?> *??</option>
<?php 
      }else    {
            ?>
<option value='<?= $i ?>' <?=checkSelN($repTable->dimHistoryOption[0], $i) ?>><?=HistoryOptions::getKlartext($i) ?></option>
<?php 
}
?>
</select></span>
<span id='HistDate<?= $tc ?>.0' <?php if ($repTable->dimHistoryOption[0] != 6) echo 'class="hidden"' ?>><?=WSRTranslate::translate("Datum")?>: 
<input onchange="setHistDatum(<?= $tc ?>,0,this.value)" size="13" value="<?=$hDatum ?>" /></span>            
<div class="lw"><b><?=WSRTranslate::translate("Dimensionen")?>:</b>
<?php 
foreach($tQuery->dimensions as $nr => $dim){
    if (false) $dim = new Dimension(null);
    if ($dim->histType > 0){
        if (! $query->reportHasDim($repTable->kennzeichen , $nr)) continue; 
        if ($repTable->dimHistoryOption[$nr] == HistoryOptions::HSDATUM && isValid($repTable->dimHistoryDate[$nr]))
            $hDatum =  WSRFormats::formatDate(DateTime::createFromFormat('Y-m-d',$repTable->dimHistoryDate[$nr]));
            else $hDatum = '';
            ?>
<br>&nbsp;&nbsp;
<?=$dim->dimName ?> (<?=WSRTranslate::translate("Hist.")?>: <?=Query::getHistText($dim->histType)?>) 
<select onchange="setHistOption(<?= $tc ?>,<?=$dim->dimNr ?>,this.value)">
<option value='0' <?=checkSelN($repTable->dimHistoryOption[$nr], 0) ?>>&nbsp;</option>
<?php
for ($i = 1; $i <= 7; $i++){
?>
<option value='<?= $i ?>' <?=checkSelN($repTable->dimHistoryOption[$nr], $i) ?>><?=HistoryOptions::getKlartext($i) ?></option>
<?php
}
?>
</select>
<span id='HistDate<?= $tc ?>.<?=$nr ?>' <?php if ($repTable->dimHistoryOption[$nr] != 6) echo 'class="hidden"' ?>>Datum: 
<input onchange="setHistDatum(<?= $tc ?>,<?=$nr ?>,this.value)" size="13" value="<?=$hDatum ?>" /> </span>
<?php
    } // if histType > 0
} // ende Schleife Dimensionen
?>
</div>
<br>        
</div></div>    
<?php 
} // ende Schleife
?>            
 

