<?php 
/**
 * Projekt: WS-Reporter
 *          Ausgabe der verknüpften Datenquellen im Report-Editor
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    6.7.2022 ms
 *
 */

global $query;
?>

	<table>
		<tr><th colspan ="2">Name</th><th class = "center">Prefix</th><th>Typ</th><th>löschen</th></tr>
		<?php 
		for ($i = 0; $i < $query->repTables->size(); $i++){
			$jt = $query->repTables->getPos($i);
		?>
		<tr><th class="left" <?=makeTitle($jt->query->table_description) ?>><?=$jt->query->class_table ?></th>
		<th><?=$jt->kennzeichen ?></th>
		<td ><input type="text"  onchange="setJoinPrefix(<?=$i ?>,this.value)" value="<?=$jt->prefix ?>" /></td>
		<td class="help" title=
"<?=WSRTranslate::translate("Werte: Es werden nur Zeilen angezeigt, die in der Basisquelle vorkommen.
Werte mit Zeilen: Es werden auch alle Zeilen aus dieser Quelle angezeigt.
Spalten: Werte aus dieser Quelle werden in Spalten aus dieser Quelle angezeigt.")?>"		
		>
		<select onchange="setJoinType(<?=$i ?>,this.value)">
		<option value="<?=JoinedTable::JOINWERTE ?>" <?=checkSel(JoinedTable::JOINWERTE, $jt->joinType) ?>  ><?=WSRTranslate::translate("Werte")?></option>
		<option value="<?=JoinedTable::JOINOUTERWERTE ?>" <?=checkSel(JoinedTable::JOINOUTERWERTE, $jt->joinType) ?> ><?=WSRTranslate::translate("Werte mit Zeilen")?></option>
		 <!--  ?    Funktioniert nicht mit MariaDB -->
		<option value="<?=JoinedTable::JOINSPALTEN ?>" <?=checkSel(JoinedTable::JOINSPALTEN, $jt->joinType) ?> ><?=WSRTranslate::translate("Spalten")?></option>
		</select>
		</td>
		<td class="center"><img src="./icons/delete.png" alt="<?=WSRTranslate::translate("löschen")?>" 
		title="<?=WSRTranslate::translate("Tabelle entfernen")?>" class="icon" onclick="removeJoin('<?=$i?>')" /></td>
		
		</tr>
		<?php 
		}
		?>
	</table>