<?php
/**
 * Projekt: WS-Reporter
 *          Ausgabe der Zeilenspezifikation des Report-Editors
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    4.3.2023 ms
 *
 */

if (false){
    $metaRecord = new MetaRecord();
    $qRows = new Vector();
    $repRow = new RepRow("N");
}

$qRows = $query->repRows;

    for ($i = 0; $i < $qRows->size(); $i++){
        $repRow = $qRows->getPos($i);
        if ($repRow->webLinkColumn){
            $label = 'Link-Spalte:';
            for ($j=0; $j < $i; $j++){
                $label = "&nbsp;&nbsp;".$label;
            }
            $cl = "nowrap ";
            $ctitle = WSRTranslate::translate("Zusätzliche Spalte für")."\n".WSRTranslate::translate("Web-Link oder Report-Aufruf");
            if ($i % 2 == 0) $cl .= " lw";
            ?>
            <div class="<?=$cl ?>" <?php drop("'Zeilen'", $i, 'drop')?>>
            <div class="nowrap">
            <span <?php drag("'Zeilen'", $i, 'drop')?>>
            <span <?=makeTitleClass($ctitle,'')?>><b><?=$label?></b></span></span>
            <input type="text" class="white" value="<?=$repRow->web_link_title ?>" size="20"           
            title='<?=WSRTranslate::translate('Spalten-Überschrift')?>'
            onchange="setPosAttribute('Zeilen',<?=$i ?>,'web_link_title',this.value)" />
            &rArr;
            <input type="text" class="white" value="<?=$repRow->web_link_value ?>" size="10" 
            title='Link-Text'
            onchange="setPosAttribute('Zeilen',<?=$i ?>,'web_link_value',this.value)" />
            
            <span 
            <input></span>
            
<?php             
        }else{  // normaler Eintrag
            $metaRecord = $query->metaData[$repRow->getName()];
            if ($metaRecord == null) $label = WSRTranslate::translate('FEHLER').': '
                        .$repRow->getName().' '.WSRTranslate::translate('hat keine Metadaten.');
            else $label = $metaRecord->label;
            for ($j=0; $j < $i; $j++){
                $label = "&nbsp;&nbsp;".$label;
            }
            $cl = "nowrap ";
            if ($i % 2 == 0) $cl .= " lw";
            ?>
            <div class="<?=$cl ?>" <?php drop("'Zeilen'", $i, 'drop')?>>
            <div class="nowrap">
            <span <?php drag("'Zeilen'", $i, 'drop')?>>
            <span <?=makeTitleClass(makeTitleDescription($metaRecord),'')?>><b><?=$label?></b></span></span>&nbsp;&nbsp;Sort.:
            <select class="small" onchange="setPosAttribute('Zeilen',<?=$i ?>,'sort',this.value)">
<?php
            foreach (Sort::klartext as $sn => $st){
               if ($sn > 0)
                echo  '<option value="'.$sn.'" '.checkSel($sn,$repRow->sort).' >'.$st."</option>\n";
            }
?> 	 
            </select>
            <input type="checkbox" onchange="setPosAttribute('Zeilen',<?=$i ?>,'summenZeilen',this.checked)" 
                    <?=checked($repRow->summenZeilen) ?> /> <?=WSRTranslate::translate('Summenzeile')?>
            <input type="checkbox" onchange="setPosAttribute('Zeilen',<?=$i ?>,'fixedTableColumns',this.checked)"
            <?=checked($repRow->fixedTableColumns)?> /> <?=WSRTranslate::translate('Label fixieren')?> &nbsp;&nbsp;
<?php } // Normaler Eintrag?>            
            <div class="nowrap right">
            <img src="./icons/go-up.png"   alt="<?=WSRTranslate::translate('links')?>" 
            	title="<?=WSRTranslate::translate('nach oben (links) verschieben')?>" class="icon" onclick="moveUp('Zeilen',<?=$i?>)" />
            <img src="./icons/go-down.png" alt="<?=WSRTranslate::translate('rechts')?>" 
            	title="<?=WSRTranslate::translate('nach unten (rechts) verschieben')?>" class="icon" onclick="moveDown('Zeilen',<?=$i?>)" />
            <img src="./icons/delete.png" alt="<?=WSRTranslate::translate('löschen')?>" 
            	title="<?=WSRTranslate::translate('Zeile löschen')?>" class="icon" onclick="deleteVar('Zeilen',<?=$i?>)" />
            </div>
            </div>
            <br>
            <?php
            $size=50;
            for ($j=0; $j < $i; $j++){
                echo "&nbsp;&nbsp;";
                $size --;
            }
            ?>
            
            <span class="help" title="<?=WSRTranslate::translate('Hier kann
* der Name eines auzurufenden Reports oder
* eingeleitet mit einem # der Name einer Spalte mit einer Internetadresse
eingegeben werden.
Hinter dem # muss der interne Name in der Datenquelle, nicht das hier 
angezeigte Label, stehen.
Auswahlliste mit Muster? bzw. #?')?>"><?=WSRTranslate::translate('verl. Report')?></span>:
            <input type="text" class="white" value="<?=$repRow->web_link ?>" size="<?=$size ?>" 
            onchange="setPosAttribute('Zeilen',<?=$i ?>,'web_link',this.value)" />
            <br>
            <?php
            if ($query->showMuster == 201 && $query->musterZiel == $i){
                // Reportauswahl anzeigen
                $liste = $query->musterListe;
                echo WSRTranslate::translate('Report-Auswahl (ggf. anklicken)').':<br><table>';
                foreach ($liste as $name => $label){
                    ?>
<tr <?=makeTitle($label[1])?>><th class="left" onclick="setPosAttribute('Zeilen',<?=$i ?>,'web_link','<?=$name ?>')"><?=$label[0] ?></th>
</tr>
    <?php
	 }
	 ?>
	 <tr>
	 <th onclick="closeMuster(201)" ><?=WSRTranslate::translate('schließen')?></th></tr>
	 </table>	 
<?php
            }
// Das Überschreiben des Link-Titels hier gibt es erstmal nicht
            if (isValid($repRow->web_link)){
                if (strpos('#',$repRow->web_link) == 0){ // Also praktisch immer :-)
                    ?>
        <span class="help" 
        title="<?=WSRTranslate::translate('Beschreibung des externen Links
ACHTUNG: Die sollte in der Datenquelle gesetzt sein
und hier nur in Ausnahmefällen überschrieben werden.')?>"><?=WSRTranslate::translate('Beschreibung')?>:</span>:
        <input type="text" class="white" value="<?=quoteForText($repRow->web_title) ?>" size="45"
            onchange="setPosAttribute('Zeilen',<?=$i ?>,'web_title',this.value)" />
            <br>
<?php
                }
                ?>
        <span class="help" title="<?=WSRTranslate::translate('Name des Fensters
leer: im selben Fenster
_blank: in neuem Fenster
Fenstername')?>"><?=WSRTranslate::translate('Fenster')?>:</span>:
        <input type="text" class="white" value="<?=quoteForText($repRow->web_target) ?>" size="45"
            onchange="setPosAttribute('Zeilen',<?=$i ?>,'web_target',this.value)" />
            <br>
<?php
            }
            for ($j=0; $j < $i; $j++){
                echo "&nbsp;&nbsp;";
            }
            ?>
            <input type="checkbox" onchange="setPosAttribute('Zeilen',<?=$i ?>,'webCopyFilter',this.checked)"
            <?=checked ($repRow->webCopyFilter) ?> /> <span class="help" title=
"<?=WSRTranslate::translate('Wenn diese Option gesetzt ist, werden zusätzlich die 
Filter aus dem Aufruf (addFilter-Parameter) und die
hier eingegebenen Zusatz-Filter übergeben.
Die normalen Filter aus der Report-Definition selbst, 
werden nicht übergeben.')?>"
><?=WSRTranslate::translate('Filter übernehmen')?></span>
            
            </div> <br>
            <?php
    }

?>
<input type="checkbox" <?=checked($query->values_in_columns) ?>
onchange="setQAttribute('values_in_columns',this.checked);load('Zeilen')"> <?=WSRTranslate::translate('Werte in Spalten')?>
<?php
if ($query->values_in_columns){
?>
&nbsp;&nbsp;<?=WSRTranslate::translate('beim Zuklapen')?>: <select onchange="setQAttribute('valueColumnFolderMode',this.value)">
<option value='' <?= checkSel($query->valueColumnFolderMode, '')?>>-- <?=WSRTranslate::translate('nicht aktiv')?> --</option>
<option value='WSFHeader' <?= checkSel($query->valueColumnFolderMode, 'WSFHeader')?>><?=WSRTranslate::translate('erste Zeile anzeigen')?></option>
<option value='WSFSummen' <?= checkSel($query->valueColumnFolderMode, 'WSFSummen')?>><?=WSRTranslate::translate('letzte Zeile anzeigen')?></option>
</select>
<?php
}
?>
<br>
<hr>
<div class="nowrap"><?=WSRTranslate::translate('hinzufügen')?>:
<select name="selRow" onchange="addVar('Zeilen',this.value)">
 <option value="" >--</option>
<?php 
if ($query->rowVars != null)
for ($i=0; $i < count($query->rowVars); $i++)
    if (! $query->repRows->has($query->rowVars[$i])
        && ($query->repColumns == null || !$query->repColumns->has($query->rowVars[$i]))
            ){
        $name = $query->rowVars[$i];
        $metaRecord = $query->metaData[$name];
        if ($metaRecord == null) echo '<option>'.WSRTranslate::translate('FEHLER').': '.$name
        .' '.WSRTranslate::translate('hat keine Metadaten').'</option>';
        else if ($metaRecord->hidden) continue;
        else if (!isValid($query->repRowsMuster) || (stripos($metaRecord->label, trim($query->repRowsMuster)) !== false)){
        ?>
 <option value="<?=$name ?>" <?=makeTitle($metaRecord->description)?>><?=$metaRecord->label?></option>
<?php
        }
}
?>
 <option value="*webLinkColumn" title="<?=WSRTranslate::translate('Zusätzliche Spalte für einen weiteren Link')?>"># Web-Link / Report-Aufruf</option>
</select>
<span class="help" title="<?=WSRTranslate::translate('Muster zum Einschränken des Auswahlliste')?>"><?=WSRTranslate::translate('Suche')?></span>
<input type="text"  value="<?=$query->repRowsMuster ?>" onchange="setSAttribute('repRowsMuster',this.value,'Zeilen')" />
</div>

