<?php
/**
 * Projekt: WS-Reporter
 *          Globale Attribute einer Report-Definition eintragen
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    21.02.2023
 *
 */
require_once './includes/wsrTranslate.inc';
global $query;
// error_log(print_r($_REQUEST,true));
switch ($_REQUEST['attribute']){
    case 'title': $query->title = trim($_REQUEST['value']);
    $query->titleModified = true;
    return;
    case 'kommentar': $query->kommentar = $_REQUEST['value'];
    return;
    case 'report_hints': $query->report_hints = $_REQUEST['value'];
    return;
    case 'display_charts': $query->display_charts = $_REQUEST['value'];
    return;
    case 'chart_size': $query->chart_size = $_REQUEST['value'];
    return;
    case 'fix_labelColumns': 
        if ($_REQUEST['value'] == 'true') $query->fix_labelColumns = true;
        else $query->fix_labelColumns = false;
    return;
    case 'sort_mode': $query->sort_mode = 1* $_REQUEST['value'];
    return;
    case 'folderMode': $query->folderMode = $_REQUEST['value'];
    return;
    case 'repGeldFaktor': $query->repGeldFaktor = $_REQUEST['value'];
    return;
    case 'repRowsMuster': $query->repRowsMuster = $_REQUEST['value'];
    return;
    case 'repColumnsMuster': $query->repColumnsMuster = $_REQUEST['value'];
    return;
    case 'repValuesMuster': $query->repValuesMuster = $_REQUEST['value'];
    return;
    case 'repFilterMuster': $query->repFilterMuster = $_REQUEST['value'];
    return;
    case 'addFilterMuster': $query->addFilterMuster = $_REQUEST['value'];
    return;
    case 'repWerteBasis': $query->repWerteBasis = $_REQUEST['value'];
    return;
    case 'repWerteAuswahl': $query->repWerteAuswahl = $_REQUEST['value'];
    return;
    case 'repWerteAuswahlTitel': $query->repWerteAuswahlTitel = $_REQUEST['value'];
    return;
    case 'repWerteAuswahlLabel': 
        if ($_REQUEST['value'] == 'true') $query->repWerteAuswahlLabel = true;
        else $query->repWerteAuswahlLabel = false;
    return;
    case 'repWerteAuswahlSelector':
        if ($_REQUEST['value'] == 'true') $query->repWerteAuswahlSelector = true;
        else $query->repWerteAuswahlSelector = false;
        return;
    case 'values_in_columns':
        if ($_REQUEST['value'] == 'true') $query->values_in_columns = true;
        else $query->values_in_columns = false;
    return;
    case 'valueColumnFolderMode': $query->valueColumnFolderMode = $_REQUEST['value'];
    return;
    case 'dropSummen':
        if ($_REQUEST['value'] == 'true') $query->dropSummen = true;
        else $query->dropSummen = false;
    return;
    case 'translation_de':
        if ($_REQUEST['value'] == 'true' and false === array_search('de', $query->rTranslations) ) $query->rTranslations[] = 'de';
        if ($_REQUEST['value'] == 'false' and false !== array_search('de', $query->rTranslations) )
            unset($query->rTranslations[array_search('de', $query->rTranslations)]);
            return;
            
    case 'translation_en':
        if ($_REQUEST['value'] == 'true' and false === array_search('en', $query->rTranslations) ) $query->rTranslations[] = 'en';
        if ($_REQUEST['value'] == 'false' and false !== array_search('en', $query->rTranslations) )
            unset($query->rTranslations[array_search('en', $query->rTranslations)]);
            return;
            
    case 'translation_fr':
        if ($_REQUEST['value'] == 'true' and false === array_search('fr', $query->rTranslations) ) $query->rTranslations[] = 'fr';
        if ($_REQUEST['value'] == 'false' and false !== array_search('fr', $query->rTranslations) )
            unset($query->rTranslations[array_search('fr', $query->rTranslations)]);
            return;
    case 'neuerReport':
        $query->reportID = 0;
        $query->title_de = null;
        $query->title_en = null;
        $query->title_fr = null;
        echo WSRTranslate::translate('Der Report wird als neue Kopie gespeichert.');
        return;
    case 'release':
        if ($query->reportID <= 0){
            echo WSRTranslate::translate('Fehler').":\n";
            echo WSRTranslate::translate('Der Report muss vor der Freigabe gespeichert werden.');
            return;
        }
        $sql = new SqlAbfrage('WSR');
        $sql->sql = 'update wsrAdminReport set timeReleased = sysdate()';
        $sql->addKlausel(', userReleased = ', $_SESSION['Name']);
        $sql->addSel('reportID = ',$query->reportID);
        $sql->execute();
        echo WSRTranslate::translate('Der Report wurde freigegeben.');
        return;
}




http_response_code(425);
echo 'Unbekanntes Attribut: '.$_REQUEST['attribute'];
