<?php
/**
 * Projekt: WS-Reporter
 *          Installation des WS-Reporters
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    7.10.2021
 *
 * Installation des WS-Reporters. 
 * Nach dem Anlegen von phpsec/createDBH.inc und 
 * dem ersten administrativen User wird dieser Aufruf gesperrt.  
 */
global $dbh, $meldung, $fertig;
require_once './includes/funktionen.inc';
if (session_status() == PHP_SESSION_NONE)  session_start();
$token = hrtime(true);
setcookie('WS-Report-Token',$token,['SameSite' => "Strict", 'path' => '/'] );
$_SESSION['Token'] = $token;

if (file_exists('./phpsec/createDBH.inc')){
    global $dbh;
    require_once './phpsec/createDBH.inc';
    if ($dbh != null){
        $stmt = $dbh->query('select user, userLongName from wsrUser where adminRecht');
        if ($z = $stmt->fetchObject()){
            echo "Die Installation ist beendet.<br>Bitte melden sie sich mit dem Benutzer";
            if (strlen($z->userLongName)>5) echo ' von '.$z->userLongName.' an.<br>';
            else echo ' '.$z->user.' an.<br>';
            echo '<a href="./index.php">zur Anmeldung</a>';
            if (array_key_exists('Anmeldung', $_SESSION)) unset ($_SESSION['Anmeldung']);
            die();            
        }
    }    
}

if (array_key_exists('action', $_REQUEST)){
    if ($_REQUEST['action'] == "anmelden"){
        $anmeldung = array();
        $anmeldung['datenbank'] = $_REQUEST['datenbank'];
        $anmeldung['benutzer'] = $_REQUEST['benutzer'];
        $anmeldung['passwort'] = $_REQUEST['passwort'];
        try {
            $dbh = new PDO($anmeldung['datenbank'], $anmeldung['benutzer'], $anmeldung['passwort']);
            $_SESSION['Anmeldung'] = $anmeldung;
        } catch (PDOException $e) {
            $meldung = "<p>Ungültige Anmeldung</p>Connection failed: " . $e->getMessage();
        }
    }
    if ($_REQUEST['action'] == "abmelden"){
        unset ($_SESSION['Anmeldung']);
        $meldung = "<p>Sie wurden abgemeldet.</p>";
    }   
    
    if ($_REQUEST['action'] == "Installation testen"){
        unset ($_SESSION['Anmeldung']);
        $meldung = "<p>Wenn Sie diese Meldung sehen, wurde die Installation noch nicht korrekt abgeschlossen.<br>"
            ."Möglicherweise kann der Server die Datei createDBH.inc nicht lesen.</p>";
    }
    
    if ($_REQUEST['action'] == "Tabellen Erstellen"){        
        if (array_key_exists('Anmeldung', $_SESSION)){
            $anmeldung = $_SESSION['Anmeldung'];
            try {
                $dbh = new PDO($anmeldung['datenbank'], $anmeldung['benutzer'], $anmeldung['passwort']);
                $_SESSION['Anmeldung'] = $anmeldung;
            } catch (PDOException $e) {
                $meldung = "<p>Ungültige Anmeldung</p>Connection failed: " . $e->getMessage();
            }
        }
        echo "<br>Erstelle die Tabellen<br>";
        require './phpsec/installieren.inc';
        if ($fertig) $_SESSION['tabellenErstellt'] = true;
        else error_log('FEHLER beim erstellen der Tabellen');
    }
    
    if ($_REQUEST['action'] == "Zugriff einrichten"){
        
        if (array_key_exists('Anmeldung', $_SESSION)){
            $anmeldung = $_SESSION['Anmeldung'];
            header("Content-Type: text/plain; charset=UTF-8");
            header("Content-Disposition: attachment; filename=\"createDBH.inc\"");
            $datei = <<<EOD
<?php
    function exception_handler( \$exception) {
        echo "<br>Es ist ein unerwarteter Fehler aufgetreten: " . \$exception->getMessage()
                 ."\\n<br>Bitte benachrichtigen Sie den System-Administrator.";
        die();
    }
set_exception_handler('exception_handler');

global \$dbh, \$dbDWH, \$dwhListe;
EOD;       
            $datei.="\n\n\$dbh = new PDO('".$anmeldung['datenbank']."','".$_REQUEST['benutzer']."','".$_REQUEST['passwort']."');\n";
            $datei.="\$dbh->setAttribute(PDO::ATTR_EMULATE_PREPARES, false);\n\n";
            
            $datei .= <<<EOD

            // Default Variablen für Historisierung
            // Wird beim Initalisieren von Datenquellen verwendet

            \$defaultGueltigAb  = 'gueltig_ab';
            \$defaultGueltigBis = 'gueltig_bis';
            \$defaultStichtag   = 'gueltig';

EOD;            

            if (isValid($_REQUEST['DWH']) && isValid($_REQUEST['DWHbenutzer']) && isValid($_REQUEST['DWHpasswort'])){
                $datei .= <<<EOD
            \$dwhListe = array('DWH','Standard');
            \$dbDWH = null;
            
            
            function setdbDWH(){
                global \$dbh , \$dbDWH, \$query;
                if (\$query == null || \$query->dwh == null) {
                    \$dbDWH = \$dbh;
                    return \$dbh;
                }
                switch (\$query->dwh) {
                    case null:
                    case '':
                    case 'Standard':
                        \$dbDWH = \$dbh;
                        return \$dbh;
                        ;
                        break;
                    case 'DWH':
                        \$dbDWH = new PDO('{$_REQUEST['DWH']}', '{$_REQUEST['DWHbenutzer']}', '{$_REQUEST['DWHpasswort']}');
                        // Bei Problemen auf true setzen
                        \$dbDWH->setAttribute(PDO::ATTR_EMULATE_PREPARES, false);
                        return \$dbDWH;
                        ;
                        break;
                        
                    default: echo 'Ungültige DWH-Anforderung '.\$query->dwh;
                    die();
                    ;
                    break;
                }
            }
EOD;         
            }else{
            $datei .= <<<EOD
            \$dwhListe = array('Standard');
            \$dbDWH = null;
            
            
            function setdbDWH(){
                global \$dbh , \$dbDWH, \$query;
                \$dbDWH = \$dbh;
                return \$dbh;
            }
/** Bei anderen Datenbanken für Daten anpassen:
                if (\$query == null || \$query->dwh == null) {
                    \$dbDWH = \$dbh;
                    return \$dbh;
                }
                switch (\$query->dwh) {
                    case null:
                    case '':
                    case 'Standard':
                        \$dbDWH = \$dbh;
                        return \$dbh;
                        ;
                        break;
                    case 'xyz':
                        \$dbDWH = new PDO('mysql:host=localhost;dbname=XYZ;character set=utf8;collate=utf8_german2_ci', 'USER', 'PASSWORT');
                        \$dbDWH->setAttribute(PDO::ATTR_EMULATE_PREPARES, false);
                        return \$dbDWH;
                        ;
                        break;
                        
                    default: echo 'Ungültige DWH-Anforderung '.\$query->dwh;
                    die();
                    ;
                    break;
                }
            }
**/
EOD;           
            }
            $datei .= '?>';            
            echo $datei;
            die();
        }else $meldung.="<br>Die Anmeldung ist ungültig oder abgelaufen.";
    }
    
    
    
    
    
    if ($_REQUEST['action'] == "Administrator anlegen"){
        
        if (array_key_exists('Anmeldung', $_SESSION)){
            $anmeldung = $_SESSION['Anmeldung'];
            try {
                $dbh = new PDO($anmeldung['datenbank'], $anmeldung['benutzer'], $anmeldung['passwort']);
                $_SESSION['Anmeldung'] = $anmeldung;
            } catch (PDOException $e) {
                $meldung = "<p>Ungültige Anmeldung</p>Connection failed: " . $e->getMessage();
            }
            
            $stmt = $dbh->prepare('insert into wsrUser set password=:pass, userLongName = :longName, adminRecht = :admin, error_count = 0, user = :user');
            
       
        //        var_dump($_REQUEST);
        //        var_dump(isset($_REQUEST['admin']));
            if ($stmt === false) var_dump($dbh->errorInfo());
            else{
               
                $erg = $stmt->execute(array(
                    'user'=>$_REQUEST['benutzer'],
                    'longName'=>$_REQUEST['name'],
                    'pass'=>$_REQUEST['passwort'],
                    'admin'=> 1
                    
                ));
                if ($erg === false)var_dump($stmt->errorInfo());
                else $meldung = "Der Benutzer ".$_REQUEST['benutzer']." wurde angelegt.";
            }
            
        }
    }
    
    
    session_write_close();
    
} // ENDE Aktionen






?>
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>WSReporter: Installation</title>
<meta name="GENERATOR" content="WS-PHP: installation.php">
<link rel="stylesheet" href="./jscss/standard2.css">
<link rel="stylesheet" href="./jscss/WSReport.css" >
<script type="text/javascript" src="./jscss/installation.js">
	</script>
</head>
<?php 
if ($_SERVER["HTTP_HOST"] == "localhost:8898"){
    ?>
<body class = "entwicklung">	
<?php
} else echo '<body>';
?>
<h1>Installation des WS-Reporters</h1>
<p><b>Ablauf:</b></p>
<ol>
<li> Anmeldung mit einem administrativen Datenbank-Benutzer</li>
<li> Erstellen der Administrations-Tabellen und Views</li>
<li> Erstellen des Datenbank-Zugriffs mit dem techischen User.<br>
     Erstellen des DWH-Datenzugriffs mit einem technischen User.<br> 
     Die erstellte Datei muss dann nach phpsec kopiert werden.</li>
<li> Erstellen des administrativen Users</li> 
<li> Installation abschließen<br>    
	 Die Dateien installation.php, phpsec/installieren.inc und jscss/installation.js können dann gelöscht werden.</li> 
</ol>
<?php if (isValid($meldung)) echo $meldung;?>
<?php
if ( ! array_key_exists('Anmeldung', $_SESSION)){
    echo "<h2>Anmeldung mit administrativem Benutzer der Datenbank</h2>";
 

?>
<form action="./installation.php" method="post">
<table>
<tr><th class="left">Datenbankverbindung für WS-Reporter</th>
<td><input type="text" name="datenbank" value="mysql:host=&lt;host&gt;;dbname=&lt;datenbank&gt;" size="80" /></td></tr>
<tr><th class="left">Benutzer (Administrator)</th><td><input name="benutzer" type="text" value="" size="40" /></td></tr>
<tr><th class="left">Passwort</th><td><input name = "passwort" type="password" value="" size="40" /></td></tr>
</table>
<input type="submit" name="action" value="anmelden" />
</form>
<?php
}else if (! array_key_exists("tabellenErstellt", $_SESSION)){
?>
<h2>Installation der Reporter-Tabellen</h2>
<table><caption>Aktionen</caption>
<tr><th>Tabellen und Views erstellen</th>
<td> 
<form action="./installation.php" method="post">
<input type="submit" name="action" value="Tabellen Erstellen" />
</form>
</td></tr>

</table>
<?php
}else{
?>
<h2>Datenbank-Zugriff einrichten</h2>
<p>Geben Sie hier den technischen User für den Datenbankzugriff an.<br>
Es wird dann eine Datei <code>createDBH.inc</code> erstellt, die Sie auf dem Server im Verzeichnis phpsec ablegen müssen.
<form action="./installation.php" method="post">
<table>
<tr><th class="left">Datenbankverbindung für WS-Reporter</th>
<td><?=$_SESSION['Anmeldung']['datenbank'] ?></td></tr>
<tr><th class="left">Technischer User</th><td><input name="benutzer" type="text" value="" size="40" /></td></tr>
<tr><th class="left">Passwort</th><td><input name = "passwort" type="password" value="" size="40" /></td></tr>
<tr><th class="left">Datenbankverbindung für DWH-Daten</th>
<td><input type="text" name="DWH" value="<?=$_SESSION['Anmeldung']['datenbank'] ?>" size="80" /></td></tr>

</tr>
<tr><th class="left">Technischer User</th><td><input name="DWHbenutzer" type="text" value="" size="40" /></td></tr>
<tr><th class="left">Passwort</th><td><input name = "DWHpasswort" type="password" value="" size="40" /></td></tr>
</table>
<input type="submit" name="action" value="Zugriff einrichten" />
</form>
<h2>Administrator einrichten</h2>
<p>Geben Sie hier den ersten User für die Benutzerverwaltung und Administration der Anwendung an.</p>
<form action="./installation.php" method="post">
<table>
<tr><th class="left">User-ID</th><td><input name="benutzer" type="text" value="" size="40" /></td></tr>
<tr><td>Benutzer-Name (lang):</td><td><input name="name" type="text" size="40"/></td></tr>
<tr><th class="left">Passwort</th><td><input name = "passwort" type="password" value="" size="40" /></td></tr>
</table>
<input type="submit" name="action" value="Administrator anlegen" />
</form>
<form action="./installation.php" method="post">
<input type="submit" name="action" value="Installation testen" /> 
</form>

<?php
}
?>
<?php

?>
<form action="./installation.php" method="post">
 <input type="submit" name="action" value="abmelden" />
</form>

</body></html>