<?php
/**
 * Projekt: WS-Reporter
 *          Benutzer-Attribute und -Rechte eintragen 
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    18.11.2021
 *
 */

global $dbh;
include 'includes/defender.inc';
require_once './includes/funktionen.inc';
require_once './phpsec/createDBH.inc';
if (session_status() == PHP_SESSION_NONE)  session_start();

anmeldungPruefen();
adminRechteVerlangen();

if (array_key_exists('action', $_REQUEST)){
    /* Wird vermutlich (noch) nicht verwendet
    if ($_REQUEST['action'] == 'editUser'){
        $stmt = $dbh->prepare('select * from wsrUser where user = :user');
        $stmt->execute(array('user'=>$_REQUEST['userID']));
        if ($stmt->fetch()){
            $stmt->closeCursor();
            $stmt = $dbh->prepare('update wsrUser set password=:pass, userLongName = :longName, adminRecht = :admin, error_count = 0 where user = :user');
        }else{
            $stmt->closeCursor();
            $stmt = $dbh->prepare('insert into wsrUser set password=:pass, userLongName = :longName, adminRecht = :admin, error_count = 0, user = :user');
            
        }
        //        var_dump($_REQUEST);
        //        var_dump(isset($_REQUEST['admin']));
        if ($stmt === false) var_dump($dbh->errorInfo());
        else{
            if (array_key_exists('admin', $_REQUEST)) $admin = 1;
            else $admin = 0;
            if (array_key_exists('endUser', $_REQUEST)) $endUser = 1;
            else $endUser = 0;
            $erg = $stmt->execute(array(
                'user'=>$_REQUEST['userID'],
                'longName'=>$_REQUEST['userName'],
                'pass'=>$_REQUEST['pass'],
                'admin'=> $admin,
                'endUser'=> $endUser
                
            ));
            if ($erg === false)var_dump($stmt->errorInfo());
        }
    }
    */
    
    if ($_REQUEST['action'] == 'setStartSeite' ){
        $stmt = $dbh->prepare('update wsrUser set reportTitle = :reportTitle where user = :user');
        if (array_key_exists('userID', $_REQUEST)) $stmt->execute(array('user'=>$_REQUEST['userID'] , 'reportTitle' => $_REQUEST['startSeite']));
        else $stmt->execute(array('user'=>'' , 'reportTitle' => $_REQUEST['startSeite']));
    }
    if ($_REQUEST['action'] == 'setRolle' ){
        $stmt = $dbh->prepare('update wsrUser set rolle = :rolle where user = :user');
        if (array_key_exists('userID', $_REQUEST)) $stmt->execute(array('user'=>$_REQUEST['userID'] , 'rolle' => $_REQUEST['rolle']));
        else $stmt->execute(array('user'=>'' , 'reportTitle' => $_REQUEST['rolle']));
    }
    if ($_REQUEST['action'] == 'setLesen' && array_key_exists('userID', $_REQUEST)){
        $stmt = $dbh->prepare('select * from wsrRechte where user = :user and table_name = :table');
        $stmt->execute(array('user'=>$_REQUEST['userID'] , 'table' => $_REQUEST['datenquelle']));
        if ($stmt->fetch()){
            $stmt->closeCursor();
            echo 'OK - schon drin';
            return;
        }else{
            $stmt->closeCursor();
            $stmt = $dbh->prepare('insert into wsrRechte set table_name=:table, user = :user, adminRecht = 0');
            $stmt->execute(array('user'=>$_REQUEST['userID'] , 'table' => $_REQUEST['datenquelle']));
        }
    }
    if ($_REQUEST['action'] == 'unsetLesen' && array_key_exists('userID', $_REQUEST)){
        $stmt = $dbh->prepare('select * from wsrRechte where user = :user and table_name = :table');
        $stmt->execute(array('user'=>$_REQUEST['userID'] , 'table' => $_REQUEST['datenquelle']));
        if ($stmt->fetch()){
            $stmt->closeCursor();
            $stmt = $dbh->prepare('delete from wsrRechte where table_name=:table and user = :user');
            $stmt->execute(array('user'=>$_REQUEST['userID'] , 'table' => $_REQUEST['datenquelle']));
        }
    }
    if ($_REQUEST['action'] == 'setAdmin' && array_key_exists('userID', $_REQUEST)){
        $stmt = $dbh->prepare('select * from wsrRechte where user = :user and table_name = :table');
        $stmt->execute(array('user'=>$_REQUEST['userID'] , 'table' => $_REQUEST['datenquelle']));
        if ($stmt->fetch()){
            $stmt->closeCursor();
            $stmt = $dbh->prepare('update wsrRechte set adminRecht = 1 where table_name=:table and user = :user');
            $stmt->execute(array('user'=>$_REQUEST['userID'] , 'table' => $_REQUEST['datenquelle']));
        }else{
            $stmt->closeCursor();
            $stmt = $dbh->prepare('insert into wsrRechte set table_name=:table, user = :user, adminRecht = 1');
            $stmt->execute(array('user'=>$_REQUEST['userID'] , 'table' => $_REQUEST['datenquelle']));
            
        }
    }   
    if ($_REQUEST['action'] == 'unsetAdmin' && array_key_exists('userID', $_REQUEST)){
        $stmt = $dbh->prepare('select * from wsrRechte where user = :user and table_name = :table');
        $stmt->execute(array('user'=>$_REQUEST['userID'] , 'table' => $_REQUEST['datenquelle']));
        if ($stmt->fetch()){
            $stmt->closeCursor();
            $stmt = $dbh->prepare('update wsrRechte set adminRecht = 0 where table_name=:table and user = :user');
            $stmt->execute(array('user'=>$_REQUEST['userID'] , 'table' => $_REQUEST['datenquelle']));
        }
    }

    if ($_REQUEST['action'] == 'setFilter'){
        $stmt = $dbh->prepare('select * from wsrRechte where user = :user and table_name = :table');
        $stmt->execute(array('user'=>$_REQUEST['userID'] , 'table' => $_REQUEST['datenquelle']));
        if ($stmt->fetch()){
            $stmt->closeCursor();
            switch ($_REQUEST['attrib']){
                case 'AddFilter':
                    $stmt = $dbh->prepare('update wsrRechte set qAddFilter = :value where table_name=:table and user = :user');
                    break;
                case 'AddFilter2':
                    $stmt = $dbh->prepare('update wsrRechte set qAddFilter2 = :value where table_name=:table and user = :user');
                    break;
                case 'AddFilterVon':
                    $stmt = $dbh->prepare('update wsrRechte set qAddFilterVon = :value where table_name=:table and user = :user');
                    break;
                case 'AddFilter2Von':
                    $stmt = $dbh->prepare('update wsrRechte set qAddFilter2Von = :value where table_name=:table and user = :user');
                    break;
                case 'AddFilterBis':
                    $stmt = $dbh->prepare('update wsrRechte set qAddFilterBis = :value where table_name=:table and user = :user');
                    break;
                case 'AddFilter2Bis':
                    $stmt = $dbh->prepare('update wsrRechte set qAddFilter2Bis = :value where table_name=:table and user = :user');
                    break;
                default:
                    http_response_code(425);
                    echo 'Ungültiges Attribut '.$_REQUEST['attrib'];
                    return;
            }
            $stmt->execute(array('user'=>$_REQUEST['userID'] , 'table' => $_REQUEST['datenquelle'],  'value' => $_REQUEST['value']));
        }
    }

    if ($_REQUEST['action'] == 'setUserFilter' ){
        $stmt = $dbh->prepare('select * from wsrUser where user = :user');
        $stmt->execute(array('user'=>$_REQUEST['userID']));
        if ($stmt->fetch()){
            $stmt->closeCursor();
            switch ($_REQUEST['attrib']){
                case 'AddFilter':
                    $stmt = $dbh->prepare('update wsrUser set qAddFilter = :value where  user = :user');
                    break;
                case 'AddFilter2':
                    $stmt = $dbh->prepare('update wsrUser set qAddFilter2 = :value where  user = :user');
                    break;
                case 'AddFilterVon':
                    $stmt = $dbh->prepare('update wsrUser set qAddFilterVon = :value where  user = :user');
                    break;
                case 'AddFilter2Von':
                    $stmt = $dbh->prepare('update wsrUser set qAddFilter2Von = :value where  user = :user');
                    break;
                case 'AddFilterBis':
                    $stmt = $dbh->prepare('update wsrUser set qAddFilterBis = :value where  user = :user');
                    break;
                case 'AddFilter2Bis':
                    $stmt = $dbh->prepare('update wsrUser set qAddFilter2Bis = :value where  user = :user');
                    break;
                default:
                    http_response_code(425);
                    echo 'Ungültiges Attribut '.$_REQUEST['attrib'];
                    return;
            }
            $stmt->execute(array('user'=>$_REQUEST['userID'] , 'value' => $_REQUEST['value']));
        }
    }
    
    
    if ($stmt === false){
        http_response_code(425);
        print_r($dbh->errorInfo());
    }else{
        echo 'OK';
    }
}