<?php 
/**
 * Projekt: WS-Reporter
 *          Übersetzungen der Anwendung
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    21.6.2022
 *
 * Hinweise:
 * Hier werden die Deutschen Texte aus den Programmen gesammelt und übersetzt
 *
 */

/* ??
 if (array_key_exists('class_table', $_REQUEST)){
 $sql = new SqlAbfrage('WSR');
 $sql->sql =
 }
 */
include 'includes/defender.inc';
global $dbh;
require_once './includes/funktionen.inc';
require_once './includes/classes.inc';
require_once './includes/qTranslate.inc';
require_once './includes/wsrTranslate.inc';
if (session_status() == PHP_SESSION_NONE)  session_start();
anmeldungPruefen();
adminRechteVerlangen();

error_log("Call translate WS-Reporter ".print_r($_REQUEST,true));

/* Liste der zu übersetzenden Texte */
$sql = new SqlAbfrage('WSR');
$sql->sql = 'select zaehler, qLanguageType, de, en, fr from wsrTranslations';
if (array_key_exists('en_IsNull', $_REQUEST)){
   $sql->addWhere('en is  null or en = ""'); 
}
if (array_key_exists('fr_IsNull', $_REQUEST)){
    $sql->addWhere('fr is null or fr = ""');
}
if (array_key_exists('en_Search', $_REQUEST) && isValid($_REQUEST['en_Search'])){
    $sql->addSel('en like','%'.trim($_REQUEST['en_Search']).'%');
}
if (array_key_exists('fr_Search', $_REQUEST) && isValid($_REQUEST['fr_Search'])){
    $sql->addSel('fr like','%'.trim($_REQUEST['fr_Search']).'%');
}
if (array_key_exists('de_Search', $_REQUEST) && isValid($_REQUEST['de_Search'])){
    $sql->addSel('de like','%'.trim($_REQUEST['de_Search']).'%');
}
$sql->sql.="\norder by de";
error_log('SQL: '.$sql->sql);
$stmt = $sql->execute();
if ($stmt === false){
    echo '<pre>';
    var_dump($sql);
    var_dump($dbh->errorInfo());
    die();
}

?>
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>Übersetzung des WS-Reporters</title>
<meta name="GENERATOR" content="WS-PHP: translateWS-Reporter.php">
<link rel="stylesheet" href="./jscss/standard2.css">
<link rel="stylesheet" href="./jscss/WSReport.css" >
<script type="text/javascript" src="./jscss/wsrTranslate.js">
	</script>
<script type="text/javascript" src="./jscss/tableHeader.js">
	</script>
</head>
<?php 
if ($_SERVER["HTTP_HOST"] == "localhost:8898"){
    ?>
<body class = "entwicklung">	
<?php
} else echo '<body>';
?>

<h1><?=WSRTranslate::translateHTML('Übersetzung des WS-Reporters')?></h1>

<table id='Tabelle'>
<form action="translateWS-Reporter.php" method="post" id='form'>
<thead>
<tr><th>&nbsp;</th>
<?php 
for ($i = 0; $i < count(qTranslate::SPRACHEN); $i++){
    echo '<th>'.qTranslate::SPRACHEN[$i].'</th>';
}
?>
</tr>
</thead>
<tbody>
<tr><th>&nbsp;</th>
<?php 
for ($i = 0; $i < count(qTranslate::SPRACHEN); $i++){
    echo '<th>';
    if ($i == 0) echo 'Suchen: ';
    echo '<input type = "text" value="';
    if (array_key_exists(qTranslate::SPRACHEN[$i].'_Search', $_REQUEST))
            echo $_REQUEST[qTranslate::SPRACHEN[$i].'_Search'];
    echo '" name = "'.qTranslate::SPRACHEN[$i].'_Search" /></th>';
}
?>
</tr>
<tr><th>&nbsp;</th>
<?php 
for ($i = 0; $i < count(qTranslate::SPRACHEN); $i++){
    echo '<th>';
    if ($i == 0) echo 'Nur leere Eingaben</th> ';
    else echo '<input type = "checkbox"  name = "'.qTranslate::SPRACHEN[$i].'_IsNull" /></th>';
}
?>
</tr>
<tr><th>&nbsp;</th>
<th><input type="submit" value="<?=WSRTranslate::translate('Anzeigen')?>" /><th colspan ="<?=count(qTranslate::SPRACHEN)-1 ?>">&nbsp;</th></tr>
</form>
<?php 
$c = 0;
while ($z = $stmt->fetch(PDO::FETCH_ASSOC)){
    $c ++;
    $rows = 0;
    $t = explode("\n",$z['de']);
    foreach ($t as $tz)
        if (strlen($tz) > 150) $rows += 4;
        elseif (strlen($tz) > 100) $rows += 3;
        elseif (strlen($tz) > 50) $rows += 2;
        else $rows++;
    
?>
<tr><th class="fts right"><?=$z['zaehler'] ?></th>
<th class="fts">
<textarea rows="<?=$rows?>" cols="50" readonly id='D<?=$c ?>' lang='de'>
<?=$z['de']?>
</textarea>
<span class="gButton"  title='<?=WSRTranslate::translate('Eintrag löschen')?>' onclick="deleteTranslationById('D<?=$c ?>')">DEL</span>

</td>  
<?php 
for ($l = 1; $l < count(qTranslate::SPRACHEN);$l++){
?>
<td><textarea rows="<?=$rows?>" cols="50"  
lang="<?=qTranslate::SPRACHEN[$l] ?>" id ='<?=qTranslate::SPRACHEN[$l].$c ?>'  
onchange='enter(this,"<?=qTranslate::SPRACHEN[$l] ?>","D<?=$c ?>")' >
<?= $z[qTranslate::SPRACHEN[$l]]?>
</textarea>
<span class="gButton"  title='<?=WSRTranslate::translate('Übersetzungen anzeigen')?>' onclick="showTranslationById('<?=qTranslate::SPRACHEN[$l].$c ?>')">T</span>
</td>
<?php 
}
?>
</tr>
<?php 
}

?>
</tbody>
</table>
<?=number_format($c,0,',','.') ?> Einträge
</body>
